#COMPILE EXE
#DIM ALL

'#INCLUDE "win32api.inc"
'#INCLUDE "comdlg32.inc"
'#INCLUDE "commCtrl.inc"
#INCLUDE "winSectAPI.inc"
#INCLUDE "winSect.inc"
'#INCLUDE "debug.inc"
#INCLUDE "myRoutines.inc"
#RESOURCE "winSect.pbr" 'for icon in explorer, hand for About dialog links

$Version = "winSect 1.2.3"
'GLOBAL dbug AS LONG

FUNCTION PBMAIN () AS LONG
   LOCAL nStyle, LBStyle, wi, ht, w, h, hh, gr, u, v, hTi AS LONG
   nStyle = %WS_SYSMENU OR %WS_MINIMIZEBOX
   DESKTOP GET CLIENT TO wi, ht
   ht = .90 * ht: wi = ht + 150
   DIALOG NEW PIXELS, 0, "Section Properties", , , wi, ht, nStyle TO hDlg
   addMenu hDlg
   DIALOG GET CLIENT hDlg TO w, h
   CONTROL ADD STATUSBAR, hDlg, %ID_Statusbar, "", 0, 0, 0, 0, %CCS_BOTTOM
   STATUSBAR SET PARTS hDlg, %ID_Statusbar, 150, 9999
   CONTROL GET SIZE hDlg, %ID_Statusbar TO u, v
   gr = h - v: w = gr + 150
   DIALOG SET CLIENT hDlg, w, h
   h = gr - 115: hh = h - 5
   CONTROL ADD LISTBOX, hDlg, %ID_Listbox, , 0, 0, 150, h, %LBS_NOTIFY OR %LBS_NOINTEGRALHEIGHT
   CONTROL ADD GRAPHIC, hDlg, %ID_Graph, "", 150, 0, gr, gr, %WS_DLGFRAME OR %SS_NOTIFY
   CONTROL ADD FRAME, hDlg, %ID_Frame, "", 0, hh, 150, 123
   CONTROL ADD LABEL, hDlg, %ID_Command, "", 5, hh+12, 140, 15
   CONTROL ADD LABEL, hDlg, %ID_Syntax, "", 15, hh+27, 130, 15
   CONTROL ADD TEXTBOX, hDlg, %ID_Values, "", 15, hh+50, 120, 18
   CONTROL ADD BUTTON, hDlg, %ID_Ok, "&Ok", 50, hh+75, 50, 25
   DIALOG SHOW MODAL hDlg, CALL dlgProc
END FUNCTION

CALLBACK FUNCTION dlgProc()
   LOCAL i, j, k, m, n, ok, undo, first, last, flags, inputErr, hInst, hIcon AS LONG
   LOCAL dx, dy, x, y, x1, y1, r, a, b, a1, a2, t, w, g AS DOUBLE
   LOCAL s, ss, s1, s2, syntax, z, path, f AS STRING, txt AS ASCIIZ*32
   STATIC listboxMode, pass AS LONG, helpFile AS ASCIIZ*128
   STATIC origData, newData AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         origDir = CURDIR$
         'dataFolder = specialFolder(%CSIDL_COMMON_DOCUMENTS) + "\cgdSoftware\winSect\"
         dataFolder = specialFolder(%CSIDL_COMMON_APPDATA) + "\cgdSoftware\winSect\"
         IF ISFOLDER(dataFolder) = 0 THEN createFolder(dataFolder)
         openIniFile
         'show application icon
         hInst = GetModuleHandle(BYVAL %NULL)
         hIcon = LoadImage(hInst, "sect", %IMAGE_ICON, 0, 0, %LR_DEFAULTSIZE)
         DIALOG SEND CBHNDL, %WM_SETICON, %ICON_SMALL, hIcon
         numItems = 35
         DIM descr(numItems) AS STRING
         descr(0)  = "a | x=a | y=a | m-n,a"
         descr(2)  = "# point"
         descr(3)  = "x , y"
         descr(4)  = "x ; y"
         descr(5)  = "units [arrow key]"
         descr(6)  = "units [/] angle"
         descr(7)  = "units [/]"
         descr(8)  = "click Ok to undo"
         descr(9)  = "click Ok to close"
         descr(10) = "r, node [,node]..."
         descr(11) = "xc , yc , r"
         descr(12) = "xc , yc , ro"
         descr(13) = "xc , yc , ro"
         descr(14) = "xc , yc , area"
         descr(15) = "node, section"
         descr(16) = "sect"
         descr(18) = "click Ok to reflect"
         descr(19) = "click Ok to reflect"
         descr(20) = "sect, point , angle"
         descr(21) = "sect , x , y"
         descr(22) = "sect , wt"
         descr(23) = "sect number"
         descr(25) = "# point"
         descr(26) = "x , y"
         descr(27) = "x ; y"
         descr(28) = "units u | d | " + CHR$(25) + " | " + CHR$(26)
         descr(29) = "units / angle"
         descr(30) = "units /"
         descr(31) = "units \"
         descr(32) = "un | un point"
         descr(33) = "click Ok to show"
         descr(34) = "click Ok to hide"
         descr(35) = "click Ok to view"
'         addMenu hDlg: addStatusBar

         DIM LB(numItems) AS STRING 'listbox
         LB(1)  = "Polygon Section"
         LB(2)  = "   defined point"
         LB(3)  = "   absolute coordinates"
         LB(4)  = "   relative coordinates"
         LB(5)  = "   directional keys"
         LB(6)  = "   angle"
         LB(7)  = "   right angle turn"
         LB(8)  = "   undo last node"
         LB(9)  = "   close polygon"
         LB(10) = "Fillets"
         LB(11) = "Circle section"
         LB(12) = "Arc segment"
         LB(13) = "Radial block"
         LB(14) = "Merge data"
         LB(15) = "Edit data"
         LB(16) = "Identify Section"
         LB(17) = "Build"
         LB(18) = "   x-reflection"
         LB(19) = "   y-reflection"
         LB(20) = "   rotate section"
         LB(21) = "   copy section"
         LB(22) = "   section weights"
         LB(23) = "   toggle on/off state"
         LB(24) = "Phantom Points"
         LB(25) = "   reference point"
         LB(26) = "   absolute point"
         LB(27) = "   relative point"
         LB(28) = "   up, down, left, right"
         LB(29) = "   angle"
         LB(30) = "   rt angle turn"
         LB(31) = "   fixed radius"
         LB(32) = "   undo point"
         LB(33) = "   show phantom points"
         LB(34) = "   hide phantom points"
         LB(35) = "View Log File"
         FOR i = 1 TO numItems
            LISTBOX ADD CBHNDL, %ID_Listbox, LB(i)
         NEXT i
         CONTROL SET COLOR CBHNDL, %ID_Listbox, %BLACK, %YELLOW
         CONTROL HANDLE CBHNDL, %ID_Graph TO hGraph
         GRAPHIC ATTACH hGraph, 0
         GRAPHIC COLOR %BLACK, -2
         GRAPHIC CLEAR %WHITE
         beginNew
         RAD = 0.0174532925199433##
         PI = 3.141592653589793##
         twoPI = 2*PI
         ghKbdHook = SetWindowsHookEx(%WH_KEYBOARD, CODEPTR(KeyboardHook), 0, GetCurrentThreadID)
         CONTROL SEND hDlg, %ID_Ok, %BM_SETSTYLE, %BS_DEFPUSHBUTTON, %TRUE
         helpFile = dataFolder + "\winSect.chm"
         s = REMOVE$(COMMAND$, """")
         IF LEN(s) OR lastFile THEN
            IF LEN(s) THEN thisFile = s
            IF LEN(DIR$(thisFile)) = 0 THEN
               MSGBOX "File not found", %MB_ICONWARNING, "File spec: " + thisFile: EXIT FUNCTION
            END IF
            openTheFile: IF numSections THEN updatePlot
            CONTROL SET TEXT CBHNDL, %ID_Values, ""
         END IF
         CONTROL SET FOCUS CB.HNDL, %ID_Values
      CASE %WM_INITMENUPOPUP
         menuMode = -1
      CASE %WM_EXITMENULOOP
         menuMode = 0
      CASE %WM_COMMAND
         IF CBCTL = %ID_Listbox THEN
            IF CBCTLMSG = %LBN_SETFOCUS THEN
               listboxMode = 1: intersect = 0
            ELSEIF CBCTLMSG = %LBN_DBLCLK THEN
               DIALOG SEND CBHNDL, %WM_COMMAND, %ID_Ok, 0: EXIT FUNCTION
            ELSEIF listboxMode THEN
               listboxMode = 0: prepareForInput
            END IF
         ELSEIF CBCTL = %ID_Values AND CBCTLMSG = %EN_SETFOCUS THEN
            CONTROL GET TEXT CBHNDL, %ID_Syntax TO syntax
         ELSEIF CBCTL = %ID_Ok THEN
            CONTROL GET TEXT CBHNDL, %ID_Command TO txt
            IF txt <> "Phantom Points" AND intersect = 0 THEN designAid = 0
            CONTROL GET TEXT CBHNDL, %ID_Syntax TO syntax: syntax = TRIM$(syntax)
            CONTROL GET TEXT CBHNDL, %ID_Values TO s
            IF syntax = "fixed radius" THEN designAid = 1: s = s + "\"
            s = LCASE$(REMOVE$(s, " ")): z = ",;/\udlrc"
            IF intersect THEN 'direction only, or radius only specified
               IF designAid THEN txt = "Phantom Points" ELSE txt = "Polygon Section"
               CONTROL SEND hDlg, %ID_Listbox, %LB_GETCURSEL, 0, 0 TO n
               syntax = CHOOSE$(intersect, "up", "down", "left", "right", _
                                           "angle", "rt angle", "fixed radius")
            ELSE 'test for intersect
               intersect = SWITCH(s = "u", 1, s = "d", 2, s = "l", 3, s = "r", 4, _
                             s = "/", 6, INSTR(s, "/"), 5, RIGHT$(s, 1) = "\", 7)
               IF intersect < 5 THEN
                  IF VAL(s) THEN intersect = 0
               ELSE
                  IF intersect = 5 THEN
                     angle = VAL(PARSE$(s, "/", 2)): IF angle = 0 THEN intersect = 0
                     r = VAL(PARSE$(s, "/", 1)): IF r THEN intersect = 0
                  ELSEIF intersect = 6 THEN
                     angle = angle + 90
                  ELSEIF intersect = 7 THEN
                     radius = VAL(PARSE$(s, "\", 1)): IF radius = 0 THEN intersect = 0
                  END IF
               END IF
               IF intersect THEN prepareForInput: EXIT FUNCTION
            END IF
            IF INSTR(syntax, "close") OR INSTR(syntax, "undo") THEN pass = 1
            IF INSTR(syntax, "fillets") OR INSTR(syntax, "reflection") THEN pass = 1
            IF INSTR(syntax, "hide") OR INSTR(syntax, "toggle") THEN pass = 1
            IF INSTR(txt, "View") THEN pass = 1
            IF LEN(s) = 0 AND pass = 0 AND txt <> "Identify Section" THEN EXIT FUNCTION
            IF txt = "Polygon Section" THEN
               undo = 0: pass = 0
               IF INSTR(syntax, "close") AND INSTR(s, ANY z) = 0 THEN
                  sect(sectNo).flag = 1: calcDone = 0: fileChanged = 1
                  LISTBOX SELECT hDlg, %ID_Listbox, 1
               ELSEIF INSTR(syntax, "undo") AND INSTR(s, ANY z) = 0 OR s = "un" THEN
                  IF numNodes = 0 THEN EXIT FUNCTION
                  IF sect(numSections).nType THEN
                     s = "Last section is not a polygon"
                     MSGBOX s, %MB_ICONINFORMATION, "Undo Nodes": EXIT FUNCTION
                  END IF
                  IF sect(numSections).nType = 0 AND sect(numSections).flag THEN
                     sectNo = numSections: sect(sectNo).flag = 0
                     first = sect(sectNo).first: last = sect(sectNo).last
                     FOR i = first TO last
                        IF k AND arcs(i, 3) THEN
                           s = "Fillets must be removed... ok to continue?"
                           k = myMSGBOX(s, %MB_YESNO OR %MB_ICONQUESTION, "Undo Nodes")
                           IF k = %IDNO THEN EXIT FUNCTION ELSE k = 1
                        END IF
                        arcs(i, 3) = 0
                     NEXT i
                  ELSEIF sect(sectNo).last > sect(sectNo).first THEN
                     DECR numNodes: DECR sect(sectNo).last
                  ELSE
                     DECR numSections: DECR sectNo
                     IF numNodes THEN DECR numNodes
                  END IF: undo = 1: fileChanged = 1: intersect = 0
                  'LISTBOX SELECT hDlg, %ID_Listbox, 3
               ELSE 'next polygon node
                  INCR numNodes
                  IF numNodes = 1 OR sect(sectNo).flag THEN 'begin new polygon
                     INCR numSections: sectNo = numSections
                     sect(sectNo).nType = 0: sect(sectNo).wt = 1
                     sect(sectNo).first = numNodes: sect(sectNo).last = numNodes
                     MENU SET STATE hMenu, BYCMD %IDM_CalcCG,%MF_GRAYED
                     MENU SET STATE hMenu, BYCMD %IDM_CalcAxes,%MF_GRAYED
                  ELSE 'continue existing polygon
                     sect(sectNo).last = numNodes
                  END IF
                  x = VAL(PARSE$(s, ANY ",;/", 1)): y = VAL(PARSE$(s, ANY ",;/", 2))
                  IF numNodes THEN x1 = polygons(numNodes - 1).x: y1 = polygons(numNodes - 1).y
                  IF intersect OR INSTR(s, ANY z) = 0 THEN ok = 1
                  IF INSTR(syntax, "defined") AND ok OR LEFT$(s, 1) = "#" THEN
                     n = VAL(s): IF LEFT$(s, 1) = "#" THEN n = VAL(MID$(s, 2))
                     s = ",": x = polygons(n).x: y = polygons(n).y
                  ELSEIF INSTR(syntax, "up") AND ok OR INSTR(s, "u") THEN
                     IF INSTR(s, "u") THEN s = REMOVE$(s, "u")
                     IF intersect THEN n = intersection(s, x, y)
                     IF n THEN prepareForInput: EXIT FUNCTION
                     IF LEN(s) THEN y = VAL(s): x = 0
                  ELSEIF INSTR(syntax, "down") AND ok OR INSTR(s, "d") THEN
                     IF INSTR(s, "d") THEN s = REMOVE$(s, "d")
                     IF intersect THEN n = intersection(s, x, y)
                     IF n THEN prepareForInput: EXIT FUNCTION
                     IF LEN(s) THEN y = -VAL(s): x = 0
                  ELSEIF INSTR(syntax, "left") AND ok OR INSTR(s, "l") THEN
                     IF INSTR(s, "l") THEN s = REMOVE$(s, "l")
                     IF intersect THEN n = intersection(s, x, y)
                     IF n THEN prepareForInput: EXIT FUNCTION
                     IF LEN(s) THEN x = -VAL(s): y = 0
                  ELSEIF INSTR(syntax, "right") AND ok OR INSTR(s, "r") THEN
                     IF INSTR(s, "r") THEN s = REMOVE$(s, "r")
                     IF intersect THEN n = intersection(s, x, y)
                     IF n THEN prepareForInput: EXIT FUNCTION
                     IF LEN(s) THEN x = VAL(s): y = 0
                  ELSEIF INSTR(syntax, "rt angle") AND ok OR RIGHT$(s, 1) = "/" THEN
                     IF numNodes < 3 THEN EXIT FUNCTION
                     dx = polygons(numNodes - 1).x - polygons(numNodes - 2).x
                     dy = polygons(numNodes - 1).y - polygons(numNodes - 2).y
                     lineProp dx, dy, b, a: r = x: x = -r*SIN(a): y = r*COS(a)
                     angle = a/RAD + 90: IF intersect THEN n = intersection(s, x, y)
                     IF n THEN prepareForInput: EXIT FUNCTION
                  ELSEIF INSTR(syntax, "angle") AND ok OR INSTR(s, "/") THEN
                     r = x: a = angle*RAD: x = r*COS(a): y = r*SIN(a)
                     IF intersect THEN n = intersection(s, x, y)
                     IF n THEN prepareForInput: EXIT FUNCTION
                  END IF
                  IF INSTR(s, ",") THEN
                     polygons(numNodes).x = x: polygons(numNodes).y = y
                  ELSE
                     polygons(numNodes).x = polygons(numNodes - 1).x + x
                     polygons(numNodes).y = polygons(numNodes - 1).y + y
                  END IF
                  fileChanged = 1
               END IF
               IF undo = 0 THEN 'allow repeats when undo-syntax is active
                  s = "": CONTROL SET TEXT CBHNDL, %ID_Syntax, s
                  showStatus s
               END IF
            ELSEIF txt = "Fillets" THEN
               n = PARSECOUNT(s, ",")
               IF n < 2 THEN
                  s = "Must specify at least one node"
                  MSGBOX s, %MB_ICONERROR, "Add Fillets"
                  EXIT FUNCTION
               END IF
               r = VAL(PARSE$(s, ",", 1))
               FOR i = 2 TO n
                  j = VAL(PARSE$(s, ",", i)): n = getSection(j)
                  IF sect(n).nType THEN 'not a polygon node
                     s = "Fillets may only be defined for polygon nodes"
                     MSGBOX s, %MB_ICONERROR, "Fillets": ITERATE FOR
                  END IF
                  fillet r, j: ok = 1
               NEXT i
               calcDone = 0: IF ok THEN fileChanged = 1
               LISTBOX SELECT hDlg, %ID_Listbox, 1
            ELSEIF txt = "Circle section" OR txt = "Arc segment" OR _
                   txt = "Merge data" OR txt = "Radial block" THEN
               n = PARSECOUNT(s, ","): INCR pass: k = 1
               IF txt = "Arc segment" THEN k = 2
               IF txt = "Merge data" THEN k = 3
               IF txt = "Radial block" THEN k = 4
               IF pass = 1 THEN
                  'circle: read xc, yc, radius
                  'arc segment: read xc, yc, outer radius
                  'radial block: read xc, yc, outer radius
                  'merge data:  read xc, yc, Area
                  IF n <> 3 THEN inputErr = 3: DECR pass: EXIT IF
                  INCR numSections: sectNo = numSections: sect(sectNo).flag = 1
                  INCR numNodes: sect(sectNo).first = numNodes: sect(sectNo).wt = 1
                  sect(sectNo).last = numNodes: sect(sectNo).nType = k
                  sect(sectNo).last = numNodes
                  arcs(numNodes, 1) = VAL(PARSE$(s, ",", 1))
                  arcs(numNodes, 2) = VAL(PARSE$(s, ",", 2))
                  arcs(numNodes, 3) = VAL(PARSE$(s, ",", 3))
                  IF k = 1 THEN 'circle
                     pass = 0: calcDone = 0: fileChanged = 1
                  ELSE 'arc segment or merge data
                     'prepare for next pass ------------------------------------------
                     s = "a1 , a2 , t"
                     IF k = 3 THEN
                        s = "Ixx , Iyy , Ixy"
                     ELSEIF k = 4 THEN
                        s = "angle , width , t"
                     END IF
                     showStatus s: CONTROL SET TEXT CBHNDL, %ID_Values, "": EXIT FUNCTION
                  END IF
               ELSEIF pass = 2 THEN
                  'arc segment: read a1, a2, t
                  '   pie segment when t = 0
                  '   chord when t < 0 and a2 - a1 < 180
                  '   ring when a1 = a2 = 0 and 0 < t < r
                  'radial block: read angle, w, t
                  'merge data:  read Ixx, Iyy, Ixy
                  k = sect(sectNo).nType
                  a1 = VAL(PARSE$(s, ",", 1)): IF a1 = 360 THEN a1 = 0
                  a2 = VAL(PARSE$(s, ",", 2)): IF a2 = 360 THEN a2 = 0
                  t  = VAL(PARSE$(s, ",", 3))
                  w = a2: r = arcs(numNodes, 3)
                  IF t > arcs(numNodes, 3) THEN
                     MSGBOX "t greater than r", %MB_ICONERROR, "Input Error"
                     pass = 1: EXIT SELECT
                  ELSEIF k = 4 AND w > r - t THEN
                     MSGBOX "w greater than inner radius", %MB_ICONERROR, "Input Error"
                     pass = 1: EXIT SELECT
                  ELSEIF t < 0 AND ABS(a2 - a1) >= 180 THEN
                     MSGBOX "a2 - a1 >= 180", %MB_ICONERROR, "Input Error"
                     pass = 1: EXIT SELECT
                  END IF
                  arcs(numNodes, 4) = a1: arcs(numNodes, 5) = a2: arcs(numNodes, 6) = t
                  IF t < 0 THEN arcs(numNodes, 0) = SGN(a2 - a1)
                  pass = 0: calcDone = 0: fileChanged = 1
               END IF
            ELSEIF txt = "Edit data" THEN
               'first, find out what type of section node belongs to
               IF pass = 0 THEN
                  CONTROL GET TEXT CBHNDL, %ID_Values TO s
                  nodeNo = VAL(PARSE$(s, ",", 1)): sectNo = VAL(PARSE$(s, ",", 2))
                  IF nodeNo THEN sectNo = getSection(nodeNo)
                  IF nodeNo = 0 AND sectNo = 0 THEN EXIT FUNCTION
                  IF nodeNo = 0 THEN nodeNo = sect(sectNo).last
               END IF
               INCR pass: j = sect(sectNo).nType: n = nodeNo
               s = "node" + STR$(nodeNo) + ", section" + STR$(sectNo)
               CONTROL SET TEXT CBHNDL, %ID_Syntax, s
               IF j = 0 THEN 'polygon type
                  s = "x , y , r": showStatus s
                  s = STR$(polygons(n).x) + "," + STR$(polygons(n).y) + "," + STR$(arcs(n, 3))
                  origData = s
               ELSEIF pass = 1 THEN 'circle, arc segment, radial block, or merge data
                  s = "xc , yc , r": IF j = 3 THEN s = "xc , yc , area"
                  showStatus s: n = nodeNo
                  s = STR$(arcs(n, 1)) + ", " + STR$(arcs(n, 2)) + ", " + STR$(arcs(n, 3))
                  origData = s
               END IF
               CONTROL SET TEXT CBHNDL, %ID_Values, s
               CONTROL SEND CBHNDL, %ID_Values, %EM_SETSEL, -1, 0
               CONTROL SET TEXT CBHNDL, %ID_Command, "Change values"
               txt = "Change values": EXIT FUNCTION
            ELSEIF txt = "Change values" THEN
               n = PARSECOUNT(s, ","): j = sect(sectNo).nType
               CONTROL GET TEXT CBHNDL, %ID_Values TO s
               IF j = 0 THEN 'polygon type
                  polygons(nodeNo).x = VAL(PARSE$(s, ",", 1))
                  polygons(nodeNo).y = VAL(PARSE$(s, ",", 2))
                  r = VAL(PARSE$(s, ",", 3)): IF r THEN fillet r, nodeNo
                  calcDone = 0: pass = 0: newData = s
               ELSEIF pass = 1 THEN
                  IF n <> 3 THEN inputErr = 3: DECR pass: EXIT IF
                  n = nodeNo: newData = s  'sect(sectNo).last
                  arcs(n, 1) = VAL(PARSE$(s, ",", 1))  'xc
                  arcs(n, 2) = VAL(PARSE$(s, ",", 2))  'yc
                  arcs(n, 3) = VAL(PARSE$(s, ",", 3))  'r (area for merge)
                  IF j = 1 THEN 'circle
                     pass = 0: calcDone = 0
                  ELSE 'arc segment, radial block, or merge data
                     'prepare for second pass ----------------------------------------
                     SELECT CASE j
                        CASE 2: s = "a1 , a2 , t"
                        CASE 3: s = "Ixx , Iyy , Ixy"
                        CASE 4: s = "angl , w , t"
                     END SELECT
                     showStatus s
                     s = STR$(arcs(n, 4)) + ", " + STR$(arcs(n, 5)) + ", " + STR$(arcs(n, 6))
                     origData = origData + ", " + s
                     CONTROL SET TEXT CBHNDL, %ID_Values, s:
                     CONTROL SEND CBHNDL, %ID_Values, %EM_SETSEL, -1, 0
                     pass = 2: EXIT FUNCTION
                  END IF
               ELSEIF pass = 2 THEN
                  k = sect(sectNo).nType: n = sect(sectNo).last: i = 0: j = 0
                  a1 = VAL(PARSE$(s, ",", 1)) 'Ixx for merge
                  a2 = VAL(PARSE$(s, ",", 2)) 'Iyy for merge, width for radial block
                  t  = VAL(PARSE$(s, ",", 3)) 'Ixy for merge
                  arcs(n, 4) = a1: arcs(n, 5) = a2
                  arcs(n, 6) = t: IF t < 0 THEN arcs(n, 0) = SGN(a2 - a1)
                  pass = 0: calcDone = 0: newData = newData + ", " + s
               END IF
            ELSEIF txt = "Identify Section" THEN
               n = VAL(s): IF n = 0 THEN n = lastSect + 1
               WHILE n <= numSections AND BIT(sect(n).flag, 2): INCR n: WEND
               lastSect = n: IF lastSect = numSections THEN lastSect = 0
               IF n AND n <= numSections THEN
                  fillSect = n: prepareForInput
                  showStatus "Section number " + STR$(fillSect)
                  updatePlot: EXIT FUNCTION
               END IF
            ELSEIF txt = "Build" THEN
               syntax = TRIM$(syntax): calcDone = 0
               n = PARSECOUNT(s, ",")
               IF syntax = "x-reflection" THEN
                  IF xRefl THEN
                     MSGBOX "Already reflected", %MB_ICONINFORMATION, "X Reflection": EXIT FUNCTION
                  END IF
                  xReflection
               ELSEIF syntax = "y-reflection" THEN
                  IF yRefl THEN
                     MSGBOX "Already reflected", %MB_ICONINFORMATION, "Y Reflection": EXIT FUNCTION
                  END IF
                  yReflection
               ELSEIF syntax = "rotate section" THEN
                  IF n <> 3 THEN inputErr = 3: EXIT IF
                  j = VAL(PARSE$(s, ",", 1)): n = VAL(PARSE$(s, ",", 2))
                  x = polygons(n).x: y = polygons(n).y 'center of rotation
                  a = VAL(PARSE$(s, ",", 3)) 'angle of rotation
                  rotateSect j, x, y, a
                  calcDone = 0: fileChanged = 1
               ELSEIF syntax = "copy section" THEN
                  IF n <> 3 THEN inputErr = 3: EXIT IF
                  j = VAL(PARSE$(s, ",", 1))
                  x = VAL(PARSE$(s, ",", 2)) 'new x coordinate
                  y = VAL(PARSE$(s, ",", 3)) 'new y coordinate
                  copySect j, x, y
                  calcDone = 0: fileChanged = 1
               ELSEIF syntax = "section weights" THEN
                  IF n <> 2 THEN inputErr = 2: EXIT IF
                  j = VAL(PARSE$(s, ",", 1))
                  IF j AND j <= numSections THEN
                     sect(j).wt = VAL(PARSE$(s, ",", 2))
                  END IF
                  calcDone = 0: fileChanged = 1
               ELSEIF syntax = "toggle on/off state" THEN
                  j = VAL(s)
                  IF j AND j <= numSections THEN
                     calcDone = 0: BIT TOGGLE sect(j).flag, 1
                     DIALOG SEND CBHNDL, %WM_COMMAND, %IDM_ViewNormal, 0
                     EXIT FUNCTION
                  END IF
                  calcDone = 0: fileChanged = 1
               END IF
            ELSEIF txt = "Phantom Points" THEN
               IF showAids = 0 AND INSTR(syntax, "show") = 0 THEN EXIT FUNCTION
               IF numAids < numNodes + 50 THEN
                  MSGBOX "Cannot add more phantom points", %MB_ICONWARNING, "Phantom Points": EXIT FUNCTION
               END IF
               DECR numAids: designAid = 1
               x = VAL(PARSE$(s, ANY ",;/\", 1)): y = VAL(PARSE$(s, ANY ",;/\", 2))
               IF intersect OR INSTR(s, ANY z) = 0 THEN ok = 1
               IF INSTR(syntax, "undo") OR INSTR(s, "un") THEN 'must test before "u"
                  IF LEFT$(s, 2) = "un" THEN n = VAL(MID$(s, 3)) ELSE n = VAL(s)
                  IF n = 0 THEN n = numAids
                  numAids = numAids + 2: s = "": x = 0: y = 0
                  FOR i = n TO numAids STEP -1
                     polygons(i) = polygons(i - 1)
                  NEXT i
               ELSEIF INSTR(syntax, "reference") AND ok OR LEFT$(s, 1) = "#" THEN
                  n = VAL(s): IF LEFT$(s, 1) = "#" THEN n = VAL(MID$(s, 2))
                  s = ",": x = polygons(n).x: y = polygons(n).y ':m = n
               ELSEIF INSTR(syntax, "up") AND ok OR INSTR(s, "u") THEN
                  IF INSTR(s, "u") THEN s = REMOVE$(s, "u")
                  IF intersect THEN n = intersection(s, x, y)
                  IF n THEN prepareForInput: EXIT FUNCTION
                  IF LEN(s) THEN y = VAL(s): x = 0
               ELSEIF INSTR(syntax, "down") AND ok OR INSTR(s, "d") THEN
                  IF INSTR(s, "d") THEN s = REMOVE$(s, "d")
                  IF intersect THEN n = intersection(s, x, y)
                  IF n THEN prepareForInput: EXIT FUNCTION
                  IF LEN(s) THEN y = -VAL(s): x = 0
               ELSEIF INSTR(syntax, "left") AND ok OR INSTR(s, "l") THEN
                  IF INSTR(s, "l") THEN s = REMOVE$(s, "l")
                  IF intersect THEN n = intersection(s, x, y)
                  IF n THEN prepareForInput: EXIT FUNCTION
                  IF LEN(s) THEN x = -VAL(s): y = 0
               ELSEIF INSTR(syntax, "right") AND ok OR INSTR(s, "r") THEN
                  IF INSTR(s, "r") THEN s = REMOVE$(s, "r")
                  IF intersect THEN n = intersection(s, x, y)
                  IF n THEN prepareForInput: EXIT FUNCTION
                  IF LEN(s) THEN x = VAL(s): y = 0
               ELSEIF INSTR(syntax, "rt angle") AND ok OR RIGHT$(s, 1) = "/" THEN
                  IF maxNodes - numAids < 2 THEN EXIT FUNCTION
                  dx = polygons(numAids + 1).x - polygons(numAids + 2).x
                  dy = polygons(numAids + 1).y - polygons(numAids + 2).y
                  lineProp dx, dy, b, a: r = x: x = -r*SIN(a): y = r*COS(a)
                  angle = a/RAD + 90: IF intersect THEN n = intersection(s, x, y)
                  IF n THEN prepareForInput: EXIT FUNCTION
               ELSEIF INSTR(syntax, "angle") AND ok OR INSTR(s, "/") THEN
                  r = x: a = y*RAD: x = r*COS(a): y = r*SIN(a): g = TAN(a)
                  IF intersect THEN n = intersection(s, x, y)
                  IF n THEN prepareForInput: EXIT FUNCTION
               ELSEIF INSTR(syntax, "fixed") AND ok OR RIGHT$(s, 1) = "\" THEN
                  n = fixedRadius(s, x, y): s = ","
                  IF n THEN prepareForInput: EXIT FUNCTION
               ELSEIF INSTR(syntax, "show") THEN
                  showAids = 1: INCR numAids
               ELSEIF INSTR(syntax, "hide") THEN
                  showAids = 0: INCR numAids
               ELSEIF INSTR(syntax, "absolute") OR INSTR(syntax, "relative") THEN
                  'nothing goes here
               ELSE
                  INCR numAids: EXIT FUNCTION
               END IF
               IF INSTR(s, ",") THEN
                  polygons(numAids).x = x: polygons(numAids).y = y
               ELSEIF x OR y THEN
                  polygons(numAids).x = polygons(numAids + 1).x + x
                  polygons(numAids).y = polygons(numAids + 1).y + y
               END IF
            ELSEIF txt = "View Log File" THEN
               logFile
               CONTROL SEND hDlg, %ID_Listbox, %LB_SETCURSEL, 3, 0
               prepareForInput: EXIT FUNCTION
            END IF
            IF inputErr THEN
               s = "Must input" + STR$(inputErr) + " parameters"
               MSGBOX s, %MB_ICONWARNING, "Input Error"
            ELSE
               IF newData <> origData THEN fileChanged = 1
               prepareForInput:
               n = sect(sectNo).last: newData = "": origData = ""
               CONTROL SEND hDlg, %ID_Values, %EM_SETSEL, -1, 0
               IF txt = "Change values" AND nodeNo < n THEN 'prompt to edit next node
                  CONTROL SET TEXT hDlg, %ID_Values, STR$(nodeNo + 1)
                  CONTROL SEND hDlg, %ID_Values, %EM_SETSEL, 0, -1
               END IF
               updatePlot
            END IF
         END IF
         '------------------------------------------------------------------------------------
         'respond to menus
         '------------------------------------------------------------------------------------
         SELECT CASE CBCTL
           CASE %IDM_Open
              PATH = dataFolder: f = "": ioMode = 1
              flags = %OFN_FILEMUSTEXIST + %OFN_LONGNAMES + %OFN_CREATEPROMPT + %OFN_EXTENSIONDIFFERENT
              IF ISTRUE (OpenFileDialog(BYVAL CBHNDL, BYVAL "Open File", f, BYVAL path,_
                 BYVAL "Sect Files (*.sec)|*.sec|All Files (*.*)|*.*", BYVAL "*.sec", flags)) THEN
                 IF fileChanged THEN
                    s = "File has changed..." + "Save it now?" + $CRLF + _
                        "(or the changes will be lost when the new file is loaded) "
                    n = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Save File")
                    IF n = %IDYES THEN saveTheFile
                 END IF
                 thisFile = f: initialize: openTheFile
              END IF
              ioMode = 0: updatePlot: prepareForInput
           CASE %IDM_Save
              IF LEN(thisFile) THEN
                 n = MSGBOX("Save file now?", %MB_YESNO + %MB_ICONQUESTION, "Save File")
                 IF n = %IDYES THEN fileChanged = 1: saveTheFile: saveIniFile
              ELSE
                 DIALOG SEND CBHNDL, %WM_COMMAND, %IDM_SaveAs, 0
              END IF
           CASE %IDM_SaveAs
              PATH = dataFolder: f = thisFile: ioMode = 1
              flags = %OFN_OVERWRITEPROMPT OR %OFN_HIDEREADONLY OR %OFN_LONGNAMES
              IF ISTRUE (SaveFileDialog(CBHNDL, "Save File", f, path,_
                    "Sect Files (*.sec)|*.sec|All Files (*.*)|*.*", "sec", flags)) THEN
                 thisFile = f: fileChanged = 1: saveTheFile: saveIniFile: showStatus "", 2
              END IF: ioMode = 0
            CASE %IDM_Print
               printSect: EXIT FUNCTION
            CASE %IDM_Pref
               preferences
            CASE %IDM_Exit
               DIALOG SEND CBHNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0
            CASE %IDM_Begin
               n = myMSGBOX("Begin again?", %MB_YESNO OR %MB_ICONWARNING, "Clear Screen")
               IF n = %IDYES THEN beginNew
            CASE %IDM_EditData
               LISTBOX SELECT hDlg, %ID_Listbox, 15
               prepareForInput: EXIT FUNCTION
            CASE %IDM_SectWts
               LISTBOX SELECT hDlg, %ID_Listbox, 22: prepareForInput
            CASE %IDM_DeleteSect
               IF numSections = 0 THEN EXIT FUNCTION
               n = VAL(myInput(CB.HNDL, "Section number:", "Delete Section"))
               IF n AND n <= numSections THEN
                  BIT SET sect(n).flag, 2: calcDone = 0: viewPrinAxes = 0
                  DIALOG SEND CBHNDL, %WM_COMMAND, %IDM_ViewNormal, 0
                  fileChanged = 1
               END IF
            CASE %IDM_RestoreSect
               IF numSections = 0 THEN EXIT FUNCTION
               n = VAL(myInput(CB.HNDL, "Section number:", "Restore Section"))
               BIT RESET sect(n).flag, 2: calcDone = 0: viewPrinAxes = 0
               DIALOG SEND CBHNDL, %WM_COMMAND, %IDM_ViewNormal, 0
            CASE %IDM_xReflection
               IF xRefl THEN 'undo x-reflection
                  FOR i = 1 TO numSections
                     IF BIT(sect(i).flag, 3) THEN
                        BIT RESET sect(i).flag, 3: BIT SET sect(i).flag, 2
                     END IF
                  NEXT i
                  xRefl = 0: filechanged = 1: calcDone = 0: viewPrinAxes = 0
                  MENU SET TEXT hMenu, BYCMD %IDM_xReflection, "X-reflection"
               ELSE
                  xReflection
               END IF
               updatePlot: prepareForInput
            CASE %IDM_yReflection
               IF yRefl THEN 'undo y-reflection
                  FOR i = 1 TO numSections
                     IF BIT(sect(i).flag, 4) THEN
                        BIT RESET sect(i).flag, 4: BIT SET sect(i).flag, 2
                     END IF
                  NEXT i
                  yRefl = 0: filechanged = 1: calcDone = 0: viewPrinAxes = 0
                  MENU SET TEXT hMenu, BYCMD %IDM_yReflection, "Y-reflection"
               ELSE
                  yReflection
               END IF
               updatePlot: prepareForInput
            CASE %IDM_RemoveAids
               numAids = maxNodes + 1: showAids = 1: updatePlot: prepareForInput
            CASE %IDM_LineProp 'calculate line properties
               s = myInput(CB.HNDL, "Line(m-n):", "Line Properties")
               m = VAL(PARSE$(s, "-", 1)): n = VAL(PARSE$(s, "-", 2))
               dx = polygons(n).x - polygons(m).x
               dy = polygons(n).y - polygons(m).y
               lineProp dx, dy, b, a: a = a/RAD
               s = "Length:  " + FORMAT$(b, "#.000") + $CRLF + "Angle:    " + FORMAT$(a, "#.000")
               myMsgbox s, %MB_ICONINFORMATION, "Line Properties"
            CASE %IDM_CalcCG 'calculate about centroidal axes
               calculate
            CASE %IDM_CalcAxes 'calculate about other axes
               s = myInput(CB.HNDL, "x0, y0, angle:", "Other Axes")
               IF LEN(s) = 0 THEN EXIT FUNCTION
               x = VAL(PARSE$(s, ",", 1)): y = VAL(PARSE$(s, ",", 2))
               a = VAL(PARSE$(s, ",", 3)): calcOtherAxes x, y, a
            CASE %IDM_ViewNormal
               viewWithoutNodes = 0: viewOne = 0: viewPrinAxes = 0
               lastSect = 0: zoom = 0: fillSect = 0
               MENU SET STATE hMenu, BYCMD %IDM_ViewNoNodes, %MF_UNCHECKED
               MENU SET STATE hMenu, BYCMD %IDM_ViewPrinAxes, %MF_UNCHECKED
               MENU SET STATE hMenu, BYCMD %IDM_ViewOne, %MF_UNCHECKED
               updatePlot: prepareForInput
            CASE %IDM_ViewNoNodes
               viewWithoutNodes = NOT viewWithoutNodes
               IF ViewWithoutNodes THEN n = %MF_CHECKED ELSE n = %MF_UNCHECKED
               MENU SET STATE hMenu, BYCMD %IDM_ViewNoNodes, n
               updatePlot
            CASE %IDM_ViewPrinAxes
               IF calcDone = 0 THEN calcMode = 2: calculate
               viewPrinAxes = NOT viewPrinAxes: updatePlot
               IF viewPrinAxes THEN n = %MF_CHECKED ELSE n = %MF_UNCHECKED
               MENU SET STATE hMenu, BYCMD %IDM_ViewPrinAxes, n
            CASE %IDM_ViewOne
               viewOne = VAL(myInput(CB.HNDL, "Section number:")): n = %MF_UNCHECKED
               IF viewOne AND viewOne <= numSections THEN
                  MENU SET STATE hMenu, BYCMD %IDM_CalcCG,%MF_GRAYED
                  MENU SET STATE hMenu, BYCMD %IDM_CalcAxes,%MF_GRAYED
                  n = %MF_CHECKED: updatePlot
               END IF
               MENU SET STATE hMenu, BYCMD %IDM_ViewOne, n
            CASE %IDM_IdentSect
               LISTBOX SELECT hDlg, %ID_Listbox, 16
               prepareForInput: EXIT FUNCTION
            CASE %IDM_FillSect
               fillSect = -1: updatePlot: EXIT FUNCTION
            CASE %IDM_MagnSect
               zoom = VAL(myInput(CB.HNDL, "Magnification factor:"))
               zoom = SWITCH(zoom, zoom, zoom < 1, 1, zoom > 5, 5)
               updatePlot: prepareForInput
            CASE %IDM_ShowAids
               showAids = 1: updatePlot
            CASE %IDM_HideAids
               showAids = 0: updatePlot
            CASE %IDM_ViewLog
               logFile
            CASE %IDM_Help
               HtmlHelp CBHNDL, helpFile, 0, 0
            CASE %IDM_About
               showAbout
         END SELECT
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_CLOSE THEN
            IF doNotQuit THEN FUNCTION = 1: EXIT FUNCTION
            IF myPrintOn THEN DIALOG END myPrintHandle
         END IF
      CASE %WM_DESTROY
         UnhookWindowsHookEx ghKbdHook
   END SELECT
END FUNCTION

SUB addMenu(hDlg AS LONG)
   LOCAL hFileMenu, hEditMenu, hViewMenu, hCalcMenu, hHelpMenu AS LONG
   MENU NEW BAR TO hMenu
   MENU NEW POPUP TO hFileMenu '-----------------------------------
   MENU ADD STRING, hFileMenu, "&Open", %IDM_Open, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "&Save", %IDM_Save, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "Save&As", %IDM_SaveAs, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "-", 0, 0
   MENU ADD STRING, hFileMenu, "&Print", %IDM_Print, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "P&references", %IDM_Pref, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "-", 0, 0
   MENU ADD STRING, hFileMenu, "E&xit", %IDM_Exit, %MF_ENABLED
   MENU ADD POPUP, hMenu, "&File", hFileMenu, %MF_ENABLED
   MENU NEW POPUP TO hEditMenu '-----------------------------------
   MENU ADD STRING, hEditMenu, "&Begin Again" + $TAB + "F9", %IDM_Begin, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Edit data", %IDM_EditData, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "Section &Weights", %IDM_SectWts, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Delete Section", %IDM_DeleteSect, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Restore Section", %IDM_RestoreSect, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&x-reflection", %IDM_xReflection, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&y-reflection", %IDM_yReflection, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "Remove &Phantom points", %IDM_RemoveAids, %MF_ENABLED
   MENU ADD POPUP, hMenu, "&Edit", hEditMenu, %MF_ENABLED
   MENU NEW POPUP TO hCalcMenu '-----------------------------------
   MENU ADD STRING, hCalcMenu, "&Line Properties", %IDM_LineProp, %MF_ENABLED
   MENU ADD STRING, hCalcMenu, "About &Centroid" + $TAB + "F3", %IDM_CalcCG, %MF_GRAYED
   MENU ADD STRING, hCalcMenu, "About &Other Axes" + $TAB + "Shft + F3", %IDM_CalcAxes, %MF_GRAYED
   MENU ADD POPUP, hMenu, "&Calculate", hCalcMenu, %MF_ENABLED
   MENU NEW POPUP TO hViewMenu '-----------------------------------
   MENU ADD STRING, hViewMenu, "&Normal", %IDM_ViewNormal, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "&Without Nodes", %IDM_ViewNoNodes, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "&Principal Axes", %IDM_ViewPrinAxes, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "&One-Section", %IDM_ViewOne, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "&Identify Section", %IDM_IdentSect, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "&Fill Net-Section", %IDM_FillSect, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "&Magnify", %IDM_MagnSect, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "&Show Phantom Points", %IDM_ShowAids, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "&Hide Phantom Points", %IDM_HideAids, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "&Log File" + $TAB + "Ctrl+L", %IDM_ViewLog, %MF_ENABLED
   MENU ADD POPUP, hMenu, "&View", hViewMenu, %MF_ENABLED
   MENU NEW POPUP TO hHelpMenu '-----------------------------------
   MENU ADD STRING, hHelpMenu, "&Help" + $TAB + "F1", %IDM_Help, %MF_ENABLED
   MENU ADD STRING, hHelpMenu, "&About", %IDM_About, %MF_ENABLED
   MENU ADD POPUP, hMenu, "&Help", hHelpMenu, %MF_ENABLED
   MENU ATTACH hMenu, hDlg
END SUB

SUB addStatusBar()
'   DIM sbParts(2) AS LONG
'   hStatusBar = CreateStatusWindow(%WS_CHILD OR %WS_VISIBLE, BYVAL %NULL, hDlg, 200)
'   sbParts(0) = 150
'   sbParts(1) = -1   'sets last one to right edge
'   SendMessage(hStatusBar, %SB_SETPARTS, 2, BYVAL VARPTR(sbParts(0)))
END SUB

SUB initialize()
   maxNodes = 250: numAids = maxNodes
   REDIM sect(100), polygons(maxNodes), arcs(maxNodes, 9)
   numDigits = 3: intersect = 0: fillSect = 0: zoom = 0
   sectNo = 0: numSections = 0: numAids = maxNodes + 1: showAids = 1
   numNodes = 0: calcDone = 0: fileChanged = 0: xrefl = 0: yrefl = 0
   viewWithoutNodes = 0: viewOne = 0: viewPrinAxes = 0
   'lastSect = 0
   MENU SET STATE hMenu, BYCMD %IDM_ViewNoNodes, %MF_UNCHECKED
   MENU SET STATE hMenu, BYCMD %IDM_ViewPrinAxes, %MF_UNCHECKED
   MENU SET STATE hMenu, BYCMD %IDM_ViewOne, %MF_UNCHECKED
END SUB

SUB beginNew()
   LOCAL s AS STRING
   initialize: thisFile = ""
   IF myPrintOn THEN DIALOG END myPrintHandle: myPrintOn = 0
   GRAPHIC CLEAR %WHITE
   LISTBOX SELECT hDlg, %ID_Listbox, 3
   CONTROL SET TEXT hDlg, %ID_Command, "Polygon Section"
   CONTROL SET TEXT hDlg, %ID_Syntax, "absolute coordinates"
   CONTROL SET TEXT hDlg, %ID_Values, "0, 0"
   CONTROL SEND hDlg, %ID_Values, %EM_SETSEL, 0, -1
   showStatus "x , y": showStatus thisFile, 2
END SUB

SUB prepareForInput()
   LOCAL n, k AS LONG, s, syntax AS STRING, txt AS ASCIIZ*32
   IF numNodes = 0 THEN numSections = 0
   CONTROL SEND hDlg, %ID_Listbox, %LB_GETCURSEL, 0, 0 TO n
   CONTROL SEND hDlg, %ID_Listbox, %LB_GETTEXT, n, VARPTR(txt)
   k = n + 1:  IF LEFT$(txt, 1) = " " THEN syntax = txt
   IF k > 9 AND k < 23 AND numSections AND sect(numSections).flag = 0 THEN
      k = 3: txt = "Polygon Section": syntax = "absolute coordinates"
      LISTBOX SELECT hDlg, %ID_Listbox, k
      s = "Must close polygon first"
      myMSGBOX s, %MB_ICONERROR, "Data Error"
   END IF
   WHILE n >= 0 AND LEFT$(txt, 1) = " "
      DECR n: CONTROL SEND hDlg, %ID_Listbox, %LB_GETTEXT, n, VARPTR(txt)
   WEND
   IF intersect THEN 'direction only was specified
      IF intersect <= 4 THEN
         s = CHOOSE$(intersect, "up", "down", "left", "right")
      ELSEIF intersect = 6 THEN
         s = "at right angle"
      ELSEIF intersect = 5 THEN
         s = "at" + STR$(angle) + " degrees"
      END IF
      txt = "How far " + s + "...": k = 0
      syntax = "intersecting line"
      IF intersect < 7 THEN syntax = "units or " + syntax
   END IF
   CONTROL SET TEXT hDlg, %ID_Command, txt
   CONTROL SET TEXT hDlg, %ID_Syntax, syntax
   s = descr(k)
   IF intersect = 7 THEN s = MID$(s, 4)
   showStatus s
   IF zoom THEN 'zoom
      s = "Zoom factor: " + STR$(zoom) + "  ... pan graphic window with arrow keys"
   ELSEIF refPt THEN
      s = "Reference point: " + STR$(refPt)
   ELSE
      s = ""
   END IF
   showStatus s, 2
   IF sect(numSections).flag AND viewOne = 0 THEN
      MENU SET STATE hMenu, BYCMD %IDM_CalcCG,%MF_ENABLED
      MENU SET STATE hMenu, BYCMD %IDM_CalcAxes,%MF_ENABLED
   END IF
   CONTROL SET TEXT hDlg, %ID_Values, ""
   CONTROL SET FOCUS hDlg, %ID_Values
END SUB

SUB showStatus(statusText AS STRING, OPT BYVAL pane AS LONG)
   '---------------------------------------------------------------
   'display text in two pane status bar
   'show text in pane of status bar, default pane = 1
   '---------------------------------------------------------------
   LOCAL txt AS ASCIIZ*128
   txt = statusText: pane = MAX(1, pane)
   IF pane = 1 THEN
      STATUSBAR SET TEXT hDlg, %ID_Statusbar, 1, 0, txt
   ELSE 'pane 2 default text is the file name
      IF LEN(txt) = 0 THEN txt = thisFile
      STATUSBAR SET TEXT hDlg, %ID_Statusbar, 2, 0, txt
   END IF
END SUB

FUNCTION keyboardHook(BYVAL iCode AS LONG, BYVAL wParm AS LONG, BYVAL lParm AS LONG) AS DWORD
   LOCAL i, j, n, k AS LONG
   LOCAL s, syntax AS STRING, txt AS ASCIIZ*32
   STATIC count AS LONG
   IF iCode < 0 THEN
      FUNCTION = CallNextHookEx(ghKbdHook, iCode, wParm, lParm)
      EXIT FUNCTION
   END IF
   IF iCode <> %HC_ACTION THEN EXIT FUNCTION
   INCR COUNT: IF COUNT MOD 2 = 0 THEN COUNT = 0: EXIT FUNCTION
   IF menuMode OR ioMode THEN EXIT FUNCTION
   i = GetKeyState(%VK_SHIFT) AND &H8000
   j = GetKeyState(%VK_CONTROL) AND &H8000
   SELECT CASE wParm
   CASE %VK_RETURN
      n = GetDlgCtrlID(GetFocus)
      IF n = %ID_Values THEN
         CONTROL GET TEXT hDlg, %ID_Values TO s
         n = INSTR(LEFT$(s, 1), ANY "uldrULDR")
         IF n = 0 THEN DIALOG SEND hDlg, %WM_COMMAND, %ID_Ok, 0
      END IF
   CASE %VK_ESCAPE
      IF calcMode THEN DIALOG END hCalc
      IF myPrintOn THEN DIALOG END myPrintHandle: myPrintOn = 0
      IF intersect THEN intersect = 0: prepareForInput: EXIT FUNCTION
      CONTROL SET TEXT hDlg, %ID_Values, ""
      DIALOG SEND hDlg, %WM_COMMAND, %IDM_ViewNormal, 0
      showStatus ""
   CASE %VK_LEFT, %VK_RIGHT
      IF zoom THEN
         IF wParm = %VK_RIGHT THEN k = 1 ELSE k = -1
         xZoom = xZoom + k*(xMax - xMin)/20: updatePlot
      ELSEIF numSections AND sect(numSections).flag = 0 THEN
         CONTROL GET TEXT hDlg, %ID_Values TO s
         IF wParm = %VK_LEFT THEN s = s + "l" ELSE s = s + "r"
         CONTROL SET TEXT hDlg, %ID_Values, s
         DIALOG SEND hDlg, %WM_COMMAND, %ID_Ok, 0
      END IF
   CASE %VK_UP, %VK_DOWN
      IF zoom THEN
         IF wParm = %VK_UP THEN k = 1 ELSE k = -1
         yZoom = yZoom + k*(yMax - yMin)/20: updatePlot
      ELSEIF numSections AND sect(numSections).flag = 0 AND j = 0 THEN
         CONTROL GET TEXT hDlg, %ID_Values TO s
         IF wParm = %VK_UP THEN s = s + "u" ELSE s = s + "d"
         CONTROL SET TEXT hDlg, %ID_Values, s
         DIALOG SEND hDlg, %WM_COMMAND, %ID_Ok, 0
      ELSE
         n = GetDlgCtrlID(GetFocus)
         IF n = %ID_Values THEN
            CONTROL SEND hDlg, %ID_Listbox, %LB_GETCURSEL, 0, 0 TO n
            IF wParm = %VK_UP AND n THEN DECR n
            IF wParm = %VK_DOWN AND n < numItems - 1 THEN INCR n
            CONTROL SEND hDlg, %ID_Listbox, %LB_SETCURSEL, n, 0
            prepareForInput
         END IF
      END IF
   CASE %VK_F1
      DIALOG SEND hDlg, %WM_COMMAND, %IDM_Help, 0
   CASE %VK_F3
      calculate
   CASE %VK_F9
      DIALOG SEND hDlg, %WM_COMMAND, %IDM_Begin, 0
   CASE %VK_U
      LISTBOX SELECT hDlg, %ID_Listbox, 8
      CONTROL SET TEXT hDlg, %ID_Syntax, "undo"
'      CONTROL SET TEXT hDlg, %ID_Values, ""
'      DIALOG SEND hDlg, %WM_COMMAND, %ID_Ok, 0
      IF numSections THEN prepareForInput
      FUNCTION = 1
   CASE %VK_C
      IF numSections AND sect(numSections).flag = 0 THEN
         LISTBOX SELECT hDlg, %ID_Listbox, 9
         CONTROL SET TEXT hDlg, %ID_Syntax, "close"
         DIALOG SEND hDlg, %WM_COMMAND, %ID_Ok, 0
      ELSE 'circle
         LISTBOX SELECT hDlg, %ID_Listbox, 11
      END IF:
      prepareForInput: FUNCTION = 1
   CASE %VK_L
      IF j THEN logFile
   END SELECT
   IF i OR j THEN EXIT FUNCTION
   SELECT CASE wParm
   CASE %VK_P
      CONTROL SEND hDlg, %ID_Listbox, %LB_GETCURSEL, 0, 0 TO i: INCR i
      IF i < 10 THEN n = 24 ELSE n = 1
      LISTBOX SELECT hDlg, %ID_Listbox, n
      prepareForInput: FUNCTION = 1
   CASE %VK_F
      LISTBOX SELECT hDlg, %ID_Listbox, 10
      prepareForInput: FUNCTION = 1
   CASE %VK_A
      LISTBOX SELECT hDlg, %ID_Listbox, 12
      prepareForInput: FUNCTION = 1
   CASE %VK_R
      LISTBOX SELECT hDlg, %ID_Listbox, 13
      prepareForInput: FUNCTION = 1
   CASE %VK_M
      LISTBOX SELECT hDlg, %ID_Listbox, 14
      prepareForInput: FUNCTION = 1
   CASE %VK_E
      LISTBOX SELECT hDlg, %ID_Listbox, 15
      prepareForInput: FUNCTION = 1
   CASE %VK_I
      LISTBOX SELECT hDlg, %ID_Listbox, 16
      prepareForInput: FUNCTION = 1
   CASE %VK_B
      LISTBOX SELECT hDlg, %ID_Listbox, 17
      prepareForInput: FUNCTION = 1
   CASE %VK_V
      LISTBOX SELECT hDlg, %ID_Listbox, 35
      prepareForInput: FUNCTION = 1
   END SELECT
END FUNCTION

FUNCTION getSection(nodeNo AS LONG) AS LONG
   'return section number for specified node number
   LOCAL i, j AS LONG
   FOR i = 1 TO numSections
      j = sect(i).nType
      IF j THEN 'circle, arc segment or merge data
         IF sect(i).first = nodeNo THEN j = i: EXIT FOR
      ELSE 'polygon
         IF sect(i).first <= nodeNo AND nodeNo <= sect(i).last THEN j = i: EXIT FOR
      END IF
   NEXT i
   FUNCTION = j
END FUNCTION

SUB xReflection()
   'toggle reflection about x-axis
   LOCAL i, j, k, m, n, f, numSects, first, last AS LONG
   numSects = numSections: xRefl = 1
   FOR i = 1 TO numSections
      INCR numSects: sect(numSects) = sect(i)
      sect(numSects).flag = sect(i).flag
      BIT SET sect(numSects).flag, 3
      k = sect(numSects).nType
      IF k = 0 THEN 'reflect polygons
         m = sect(i).first - 1: n = sect(i).last
         first = numNodes + 1: last = numNodes + n - m
         sect(numSects).first = first: sect(numSects).last = last
         FOR j = last TO first STEP -1
            INCR m: INCR numNodes
            polygons(j) = polygons(m)
            polygons(j).y = -polygons(m).y
            IF arcs(m, 3) THEN
               arcs(j, 0) =  arcs(m, 0)
               arcs(j, 1) =  arcs(m, 1)
               arcs(j, 2) = -arcs(m, 2)
               arcs(j, 3) =  arcs(m, 3)
               arcs(j, 4) = -arcs(m, 4)
               arcs(j, 5) = -arcs(m, 5)
               arcs(j, 6) =  arcs(m, 6)
               arcs(j, 7) = -arcs(m, 7)
               arcs(j, 8) =  arcs(m, 8)
               arcs(j, 9) = -arcs(m, 9)
               SWAP arcs(j, 4), arcs(j, 5)
               SWAP arcs(j, 6), arcs(j, 8)
               SWAP arcs(j, 7), arcs(j, 9)
            END IF
         NEXT j
      ELSE 'reflect circles, arc segments, radial blocks, and merge data
         INCR numNodes: m = sect(i).last
         sect(numSects).first = numNodes: sect(numSects).last = numNodes
         arcs(numNodes, 0) =  arcs(m, 0)
         arcs(numNodes, 1) =  arcs(m, 1)  'xc
         arcs(numNodes, 2) = -arcs(m, 2)  'yc
         arcs(numNodes, 3) =  arcs(m, 3)  'r
         arcs(numNodes, 4) = -arcs(m, 4)  'a1
         arcs(numNodes, 5) = -arcs(m, 5)  'a2
         arcs(numNodes, 6) =  arcs(m, 6)  't
         IF k < 4 THEN SWAP arcs(numNodes, 4), arcs(numNodes, 5)
      END IF
   NEXT i
   numSections = numSects: filechanged = 1: calcDone = 0: viewPrinAxes = 0
   MENU SET TEXT hMenu, BYCMD %IDM_xReflection, "Undo x-reflection"
END SUB

SUB yReflection()
   'toggle reflection about y-axis
   LOCAL i, j, k, m, n, f, numSects, first, last AS LONG
   numSects = numSections: yRefl = 1
   FOR i = 1 TO numSections
      INCR numSects: sect(numSects) = sect(i)
      sect(numSects).flag = sect(i).flag
      BIT SET sect(numSects).flag, 4
      k = sect(numSects).nType
      IF k = 0 THEN 'reflect polygons
         m = sect(i).first - 1: n = sect(i).last
         first = numNodes + 1: last = numNodes + n - m
         sect(numSects).first = first: sect(numSects).last = last
         FOR j = last TO first STEP -1
            INCR m: INCR numNodes
            polygons(j) = polygons(m)
            polygons(j).x = -polygons(m).x
            IF arcs(m, 3) THEN
               arcs(j, 0) =  arcs(m, 0)
               arcs(j, 1) = -arcs(m, 1)
               arcs(j, 2) =  arcs(m, 2)
               arcs(j, 3) =  arcs(m, 3)
               arcs(j, 4) =  180 - arcs(m, 4)
               arcs(j, 5) =  180 - arcs(m, 5)
               arcs(j, 6) = -arcs(m, 6)
               arcs(j, 7) =  arcs(m, 7)
               arcs(j, 8) = -arcs(m, 8)
               arcs(j, 9) =  arcs(m, 9)
               SWAP arcs(j, 4), arcs(j, 5)
               SWAP arcs(j, 6), arcs(j, 8)
               SWAP arcs(j, 7), arcs(j, 9)
            END IF
         NEXT j
      ELSE 'reflect circles, arc segments, radial blocks, and merge data
         INCR numNodes: m = sect(i).last
         sect(numSects).first = numNodes: sect(numSects).last = numNodes
         arcs(numNodes, 0) =  arcs(m, 0)
         arcs(numNodes, 1) = -arcs(m, 1) 'xc
         arcs(numNodes, 2) =  arcs(m, 2) 'yc
         arcs(numNodes, 3) =  arcs(m, 3) 'r
         arcs(numNodes, 4) =  180 - arcs(m, 4)
         arcs(numNodes, 6) =  arcs(m, 6) 't
         IF k < 4 THEN
            arcs(numNodes, 5) =  180 - arcs(m, 5)
            SWAP arcs(numNodes, 4), arcs(numNodes, 5)
         ELSE
            arcs(numNodes, 5) =  -arcs(m, 5)
         END IF
      END IF
   NEXT i
   numSections = numSects: filechanged = 1: calcDone = 0: viewPrinAxes = 0
   MENU SET TEXT hMenu, BYCMD %IDM_yReflection, "Undo y-reflection"
END SUB

SUB copySect(j AS LONG, x AS DOUBLE, y AS DOUBLE)
   LOCAL i, k, m, n, first, last AS LONG, r AS DOUBLE
   n = sect(j).nType: first = sect(j).first: last = sect(j).last
   INCR numSections: sect(numSections) = sect(j)
   IF n = 0 THEN 'copy polygon
      DIM saved(last - first + 1) AS DOUBLE
      FOR i = first TO last 'make copy
         'k = polygons(i).f: k = k * SGN(arcs(k, 3)):
         INCR m
         IF arcs(i, 3) THEN saved(m) = arcs(i, 3)
         polygons(numNodes + m).x = polygons(i).x + x
         polygons(numNodes + m).y = polygons(i).y + y
      NEXT i
      last = numNodes + 1 + last - first: first = numNodes + 1: numNodes = last
      sect(numSections).first = first: sect(numSections).last = last
      FOR i = first TO last 'insert fillets
         r = saved(i - first + 1)
         IF r THEN arcs(i, 3) = r: fillet r, i
      NEXT i
   ELSEIF n = 1 OR n = 2 OR n = 4 THEN 'copy circle, arc segment, or radial block
      INCR numNodes
      FOR i = 1 TO 6
         arcs(numNodes, i) = arcs(last, i)
      NEXT i
      arcs(numNodes, 1) = arcs(last, 1) + x
      arcs(numNodes, 2) = arcs(last, 2) + y
      sect(numSections).first = numNodes
      sect(numSections).last = numNodes
   END IF
END SUB

SUB rotateSect(j AS LONG, xc AS DOUBLE, yc AS DOUBLE, angl AS DOUBLE)
   '--------------------------------------------------------------------
   'rotate section j about a point xc, yc by an angle of angl degrees
   '--------------------------------------------------------------------
   LOCAL i, n, first, last AS LONG
   LOCAL dx, dy, x0, y0, x1, y1, r, b, a, a1, a2, w, rot AS DOUBLE
   n = sect(j).nType: first = sect(j).first: last = sect(j).last: rot = angl*RAD
   IF n = 0 THEN 'rotate polygon
      DIM saved(last - first + 1) AS DOUBLE
      FOR i = first TO last
         IF arcs(i, 3) THEN 'save fillet info and remove it
            saved(i - first + 1) = arcs(i, 3): fillet r, i
         END IF
         dx = polygons(i).x - xc: dy = polygons(i).y - yc
         lineProp dx, dy, r, a: a = a + rot
         polygons(i).x = xc + r*COS(a): polygons(i).y = yc + r*SIN(a)
      NEXT i
      FOR i = first TO last 'replace saved fillet info
         IF arcs(i, 3) THEN fillet saved(i - first + 1), i
      NEXT i
   ELSEIF n > 1 THEN 'rotate arc segment, radial block, or merge data
      x0 = arcs(last, 1): y0 = arcs(last, 2): r = arcs(last, 3)
      dx = x0 - xc: dy = y0 - yc
      lineProp dx, dy, b, a: a = a + rot
      arcs(last, 1) = xc + b*COS(a): arcs(last, 2) = yc + b*SIN(a)
      IF n = 2 THEN 'rotate arc segment
         arcs(last, 4) = arcs(last, 4) + angl
         arcs(last, 5) = arcs(last, 5) + angl
      ELSEIF n = 4 THEN 'rotate radial block
         arcs(last, 4) = arcs(last, 4) + angl
      END IF
   END IF
END SUB

SUB fillet(r AS DOUBLE, i AS LONG)
   'fillet arc tangent to both sides
   'fillet at node i with radius, r
   '... process row of arcs()
   '        k:    1   2   3   4   5   6   7   8   9
   'arcs(n, k)    xc  yc  r   a1  a2  x1  y1  x2  y2
   '-------------------------------------------------------
   LOCAL xi, yi, xim1, yim1, xip1, yip1, dx, dy, dx1, dy1, dx2, dy2, b1, b2, a1, a2 AS DOUBLE
   LOCAL alfa, a, b, c, u, x, y, xc, yc, x0, y0, x1, y1, x2, y2, gx, gy, rsav AS DOUBLE
   LOCAL k, first, last AS LONG
   LOCAL flag AS BYTE
   'first, find the sectNo for node i
   FOR k = 1 TO numSections
      IF sect(k).first <= i AND i <= sect(k).last THEN sectNo = k: EXIT FOR
   NEXT k
   first = sect(sectNo).first: last = sect(sectNo).last
   xi = polygons(i).x: yi = polygons(i).y
   IF i = first THEN
      xim1 = polygons(last).x: yim1 = polygons(last).y
   ELSE
      xim1 = polygons(i - 1).x: yim1 = polygons(i - 1).y
   END IF
   IF i = last THEN
      xip1 = polygons(first).x: yip1 = polygons(first).y
   ELSE
      xip1 = polygons(i + 1).x: yip1 = polygons(i + 1).y
   END IF
   dx = xim1 - xi: dy = yim1 - yi: lineProp(dx, dy, b1, a1)
   dx = xip1 - xi: dy = yip1 - yi: lineProp(dx, dy, b2, a2)
   alfa = ABS(a1 - a2): IF alfa > PI THEN alfa = 2*PI - alfa
   alfa = alfa/2: IF alfa = 0 OR alfa = PI/2 THEN EXIT SUB
   a = r/TAN(alfa): b = SQR(1 + (r/a)^2)/COS(alfa)
   x1 = xi - a/b1*(xi - xim1): y1 = yi - a/b1*(yi - yim1)
   x2 = xi + a/b2*(xip1 - xi): y2 = yi + a/b2*(yip1 - yi)
   xc = xi + b*((x1 + x2)/2 - xi): yc = yi + b*((y1 + y2)/2 - yi)
   'determine angles and store arcs() values
   dx = x1 - xc: dy = y1 - yc: lineProp(dx, dy, b1, a1)
   dx = x2 - xc: dy = y2 - yc: lineProp(dx, dy, b2, a2)
   IF a1 > a2 THEN SWAP a1, a2 'demand a2 > a1
   IF a2 - a1 >= PI THEN 'must be less than PI
      SWAP a1, a2
      IF a2 <= PI THEN a1 = a1 - 2 * PI
      IF a2 > PI THEN a1 = a1 + 2 * PI
   END IF
   arcs(i, 1) = xc: arcs(i, 2) = yc: arcs(i, 3) = r
   arcs(i, 4) = a1/RAD: arcs(i, 5) = a2/RAD
   arcs(i, 6) = x1: arcs(i, 7) = y1: arcs(i, 8) = x2: arcs(i, 9) = y2
   'now store appropriate sign in arcs(i, 0) for calculations and filling
   'first, determine section number orientation (k, counter-clockwise positive)
   'k = vector product: (dx1, dy1) x (dx2, dy2)
   dx1 = polygons(2).x - polygons(1).x: dy1 = polygons(2).y - polygons(1).y
   dx2 = polygons(3).x - polygons(2).x: dy2 = polygons(3).y - polygons(2).y
   k = SGN(dx1 * dy2 - dy1 * dx2)
   'now, determine vector product: [(xc,yc) --> (x1,y1)] x [(x1,y1) --> (x2,y2)]
   'and its sign relative to the section numbering orientation
   arcs(i, 0) = SGN((x1 - xc)*(y2 - y1) - (y1 - yc)*(x2 - x1)) * k
   EXIT SUB
END SUB

SUB lineProp(dx AS DOUBLE, dy AS DOUBLE, b AS DOUBLE, a AS DOUBLE)
   '----------------------------------------------------------------
   'compute length b and angle a of line segment defined by dx, dy
   '----------------------------------------------------------------
   b = SQR(dx*dx + dy*dy):
   IF dx = 0 THEN
      a = PI/2 * SGN(dy)
   ELSEIF dx > 0 THEN
      a = ATN(dy/dx)
   ELSE
      a = PI + ATN(dy/dx)
   END IF
   IF a < 0 THEN a = a + 2*PI
END SUB

FUNCTION intersection(s AS STRING, x AS DOUBLE, y AS DOUBLE) AS LONG
   'intersect = 1, 2  vertical direction (angle = 90)
   '          = 3, 4  horizontal direction (angle = 0)
   '          = 5, 6  angled direction (6 for rt angle)
   '          = 7     radius known, solve for angle
   'mopt = 1  target line, x=a
   '     = 2  target line, y=a
   'b0 = y-intercept of direction, g0 = slope of direction
   'b  = y-intercept of target line, g = slope of target line
   '------------------------------------------------------------------------------
   LOCAL m, n, mOpt AS LONG, s1, s2 AS STRING
   LOCAL r, rx, ry, x1, y1, g, g0, b, b0 AS DOUBLE
   IF designAid THEN n = numAids + 1 ELSE n = numNodes - 1
   x1 = polygons(n).x: y1 = polygons(n).y
   s1 = PARSE$(s, ",", 1): s2 = PARSE$(s, ",", 2): r = VAL(s2)
   IF intersect = 1 OR intersect = 2 THEN
      angle = PI/2
   ELSEIF intersect = 3 OR intersect = 4 THEN
      angle = 0
   ELSEIF intersect < 7 THEN
      angle = angle*RAD: rx = COS(angle): ry = SIN(angle): b = 1
      g0 = ry/rx: b0 = y1 - g0*x1
   ELSEIF intersect = 7 AND radius THEN
      n = fixedRadius(s, x, y): EXIT FUNCTION
   END IF
   IF LEFT$(s1, 2) = "x=" THEN
      IF ABS(COS(angle)) > .0001 THEN mOpt = 1: x = VAL(MID$(s1, 3)) ELSE g = g0
   ELSEIF LEFT$(s1, 2) = "y=" THEN
      IF ABS(SIN(angle)) > .0001 THEN mOpt = 2: y = VAL(MID$(s1, 3)) ELSE g = g0
   ELSEIF INSTR(s, "-") THEN
      m = VAL(PARSE$(s1, "-", 1)): n = VAL(PARSE$(s1, "-", 2))
      rx = polygons(n).x - polygons(m).x: ry = polygons(n).y - polygons(m).y
      b = SQR(rx*rx + ry*ry)
      IF ABS(rx)/b < .0001 THEN
         mOpt = 1: x = polygons(m).x - SGN(rx)*r
      ELSEIF ABS(ry)/b < .0001 THEN
         mOpt = 2: y = polygons(m).y + SGN(ry)*r
      ELSE
         g = ry/rx: b = polygons(m).y - g*polygons(m).x + r*SGN(rx)*SQR(1 + g*g)
         IF intersect = 1 OR intersect = 2 THEN x = x1: y = b + g*x
         IF intersect = 3 OR intersect = 4 THEN y = y1: x = (y - b)/g
      END IF
   ELSE
      intersect = 0: EXIT FUNCTION
   END IF
   IF mOpt = 1 AND (intersect = 3 OR intersect = 4) THEN
      y = y1
   ELSEIF mOpt = 2 AND (intersect = 1 OR intersect = 2) THEN
      x = x1
   ELSEIF mOpt = 1 AND (intersect = 5 OR intersect = 6) THEN
      y = b0 + g0*x
   ELSEIF mOpt = 2 AND (intersect = 5 OR intersect = 6) THEN
      x = (y - b0)/g0
   ELSEIF ABS(g - g0)/MAX(ABS(g), ABS(g0)) <= .0001 THEN
      MSGBOX "Intersect cannot be calculated", %MB_ICONERROR, "Intersection Error"
      FUNCTION = -1: intersect = 0: DECR numNodes: EXIT FUNCTION
   ELSEIF intersect > 4 THEN
      x = (b0 - b)/(g - g0): y = b0 + g0*x
   END IF
   intersect = 0: s = ""
   x = x - x1: y = y - y1
END FUNCTION

FUNCTION fixedRadius(s AS STRING, x AS DOUBLE, y AS DOUBLE) AS LONG
   LOCAL xc, yc, r, a, b, c, rx, ry, d, g, z AS DOUBLE
   LOCAL s1, s2 AS STRING
   LOCAL k, j, m, n AS LONG
   intersect = 0: k = numNodes: j = numNodes - 1
   IF designAid THEN k = numAids: j = numAids + 1  'current and prev point
   xc = polygons(j).x: yc = polygons(j).y
   r = radius: s1 = PARSE$(s, ",", 1): s2 = PARSE$(s, ",", 2): a = VAL(s2)
   IF INSTR(s, "-") THEN
      m = VAL(PARSE$(s1, "-", 1)): n = VAL(PARSE$(s1, "-", 2))
      rx = polygons(n).x - polygons(m).x: ry = polygons(n).y - polygons(m).y
      IF rx = 0 THEN s1 = "x=" + TRIM$(STR$(polygons(m).x))
   END IF
   IF LEFT$(s1, 2) = "x=" THEN
      a = VAL(MID$(s, 3))
      IF a > xc + r OR a < xc - r THEN GOTO noIntersect
      x = a - xc: y = SQR(r*r - x*x): x = a
      IF y THEN 'two intersects
         polygons(k).x = x: polygons(k).y = yc + y
         y = yc - y: IF designAid THEN DECR numAids ELSE INCR numNodes
      END IF
   ELSEIF LEFT$(s1, 2) = "y=" THEN
      a = VAL(MID$(s, 3))
      IF a > yc + r OR a < yc - r THEN GOTO noIntersect
      y = a - yc: x = SQR(r*r - y*y): y = a
      IF x THEN 'two intersects
         polygons(k).x = xc + x: polygons(k).y = y
         x = xc - x: IF designAid THEN DECR numAids ELSE INCR numNodes
      END IF
   ELSEIF INSTR(s, "-") THEN
      'line:  y = gx + d
      m = VAL(PARSE$(s1, "-", 1)): n = VAL(PARSE$(s1, "-", 2))
      rx = polygons(n).x - polygons(m).x: ry = polygons(n).y - polygons(m).y
      g = ry/rx: d = polygons(m).y - g*polygons(m).x + a*SGN(rx)*SQR(1 + g*g)
      '1st equation, line:    y = gx + d
      '2nd equation, circle: (x-xc)^2 + (y-yc)^2 = r^2
      a = 1 + g*g
      b = -2*(xc - d*g + g*yc)
      c = xc*xc + d*d + yc*yc -2*d*yc - r*r
      'solve quadradic eqn:  ax*x + bx + c = 0
      z = b*b - 4*a*c
      IF z < 0 THEN GOTO noIntersect ELSE z = SQR(z)
      x = (-b + z)/2/a: y = g*x + d
      IF z THEN 'two intersects
         polygons(k).x = x: polygons(k).y = y
         x = (-b - z)/2/a: y = g*x + d
         IF designAid THEN DECR numAids ELSE INCR numNodes
      END IF
   END IF
   EXIT FUNCTION
noIntersect:
   MSGBOX "Intersect cannot be calculated", %MB_ICONERROR, "Intersection Error"
   FUNCTION = -1: intersect = 0: DECR numNodes
END FUNCTION

SUB updatePlot()
   '----------------------------------------------------------------
   'plot section so far defined
   'noNodes = 1 to plot without showing nodes
   '----------------------------------------------------------------
   LOCAL i, j, n, k, first, last, pass, fillColor, foreColor AS LONG, showNodes AS BYTE
   LOCAL x, y, g, r, xc, yc, x0, y0, x1, y1, x2, y2, x3, y3, x4, y4, a1, a2, t, a, w AS DOUBLE
   DIM aids(numNodes) AS BYTE

   IF fillSect AND zoom = 0 THEN GOTO plotNow
   viewPrinAxes = viewPrinAxes * calcDone
   IF viewPrinAxes THEN n = %MF_CHECKED ELSE n = %MF_UNCHECKED
   MENU SET STATE hMenu, BYCMD %IDM_ViewPrinAxes, n

   'first, get size for scaling
   showNodes = viewWithoutNodes + 1
   IF noClear THEN GOTO plotNow
   xMax = -1.E99: yMax = -1.E99: xMin = 1.E99: yMin = 1.E99
   IF numSections = 0 THEN beginNew: EXIT SUB
   FOR j = 1 TO numSections
      IF BIT(sect(j).flag, 1) OR BIT(sect(j).flag, 2) THEN ITERATE
      IF j <> viewOne AND viewOne THEN ITERATE
      first = sect(j).first: last = sect(j).last
      IF sect(j).nType = 0 THEN 'size polygon
         FOR i = first TO last
            xMax = MAX(xMax, polygons(i).x): xMin = MIN(xMin, polygons(i).x)
            yMax = MAX(yMax, polygons(i).y): yMin = MIN(yMin, polygons(i).y)
         NEXT i
      ELSE 'size arc section, radial block, or merge data
         n = sect(j).last
         xc = arcs(n, 1): yc = arcs(n, 2): r = arcs(n, 3)
         a1 = arcs(n, 4): a2 = arcs(n, 5): t = arcs(n, 6)
         a = r
         IF t >= 0 AND t <= r THEN
            a = r - t: IF t = 0 THEN a = 0
         END IF
         k = sect(j).nType
         IF k < 3 THEN  'arc segment
            a1 = a1*RAD: a2 = a2*RAD
            IF a2 <= a1 OR a2 >= a1 + PI THEN
               xMax = MAX(xMax, xc + r, xc - r): xMin = MIN(xMin, xc + r, xc - r)
               yMax = MAX(yMax, yc + r, yc - r): yMin = MIN(yMin, yc + r, yc - r)
            ELSE
               xMax = MAX(xMax, xc + r*COS(a1), xc + r*COS(a2), xc + a*COS(a1), xc + a*COS(a2))
               xMin = MIN(xMin, xc + r*COS(a1), xc + r*COS(a2), xc + a*COS(a1), xc + a*COS(a2))
               yMax = MAX(yMax, yc + r*SIN(a1), yc + r*SIN(a2), yc + a*SIN(a1), yc + a*SIN(a2))
               yMin = MIN(yMin, yc + r*SIN(a1), yc + r*SIN(a2), yc + a*SIN(a1), yc + a*SIN(a2))
            END IF
         ELSEIF k = 3 THEN 'merge data
            r = 0: a = 0
            IF numNodes = 1 THEN xMax = xc + 1: xMin = xc - 1: yMax = yc + 1: yMin = yc - 1
         ELSE 'radial block
            w = a2: a1 = a1*RAD: a2 = a1 + ATN(ABS(w)/SQR(r*r-w*w))*SGN(w)
            xMax = MAX(xMax, xc + r*COS(a1), xc + r*COS(a2))
            xMin = MIN(xMin, xc + r*COS(a1), xc + r*COS(a2))
            yMax = MAX(yMax, yc + r*SIN(a1), yc + r*SIN(a2))
            yMin = MIN(yMin, yc + r*SIN(a1), yc + r*SIN(a2))
            r = r - t: a2 = a1 + ATN(ABS(w)/SQR(r*r-w*w))*SGN(w)
            xMax = MAX(xMax, xc + r*COS(a1), xc + r*COS(a2))
            xMin = MIN(xMin, xc + r*COS(a1), xc + r*COS(a2))
            yMax = MAX(yMax, yc + r*SIN(a1), yc + r*SIN(a2))
            yMin = MIN(yMin, yc + r*SIN(a1), yc + r*SIN(a2))
         END IF
      END IF
   NEXT j
   IF numAids <= maxNodes THEN
      FOR j = maxNodes TO numAids STEP -1
         xMax = MAX(xMax, polygons(j).x): xMin = MIN(xMin, polygons(j).x)
         yMax = MAX(yMax, polygons(j).y): yMin = MIN(yMin, polygons(j).y)
      NEXT j
   END IF
   x = 0.625*(xMax - xMin): IF x = 0 THEN x = 0.5
   y = 0.625*(yMax - yMin): IF y = 0 THEN y = 0.5
   g = MAX(x, y): x = (xMin + xMax)/2: y = (yMin + yMax)/2
   IF zoom THEN
      g = g/zoom: x = x + xZoom: y = y + yZoom
   END IF
   GRAPHIC SCALE (x - g, y + g) - (x + g, y - g)
   plotNow: '----------------------------------------------------------------------------
   GRAPHIC CLEAR %WHITE
   GRAPHIC COLOR %BLACK
   GRAPHIC WIDTH 1
   FOR pass = 1 TO 2 'two passes... first for solids, then for holes
      FOR j = 1 TO numSections
         'if section is turned off or deleted then iterate
         IF BIT(sect(j).flag, 1) OR BIT(sect(j).flag, 2) THEN ITERATE
         IF j <> viewOne AND viewOne THEN ITERATE
         IF pass = 1 AND sect(j).wt < 0 THEN ITERATE 'hole
         IF pass = 2 AND sect(j).wt > 0 THEN ITERATE 'solid
         IF pass = 1 AND fillSect < 0 THEN fillColor = %LTGRAY
         IF pass = 2 AND fillSect < 0 THEN fillColor = %WHITE
         IF fillSect = j THEN fillColor = %LTGRAY
         IF fillSect = 0 THEN fillColor = %BLACK
         GRAPHIC WIDTH 1
         IF fillSect < 0 OR fillSect = j THEN GRAPHIC WIDTH 2
         IF sect(j).nType = 0 THEN 'plot polygon
            first = sect(j).first: last = sect(j).last
            FOR i = first TO last
               x1 = polygons(i).x: y1 = polygons(i).y: x = x1: y = y1
               IF i < last THEN
                  x2 = polygons(i + 1).x: y2 = polygons(i + 1).y
                  IF arcs(i + 1, 3) THEN x2 = arcs(i + 1, 6): y2 = arcs(i + 1, 7)
               ELSEIF i = last AND BIT(sect(j).flag, 0) THEN
                  x2 = polygons(first).x: y2 = polygons(first).y
                  IF arcs(first, 3) THEN x2 = arcs(first, 6): y2 = arcs(first, 7)
               END IF
               IF arcs(i, 3) THEN
                  x1 = arcs(i, 8): y1 = arcs(i, 9)
                  xc = arcs(i, 1): yc = arcs(i, 2): r = arcs(i, 3)
                  a1 = arcs(i, 4)*RAD: a2 = arcs(i, 5)*RAD
                  GRAPHIC ARC (xc - r, yc + r) - (xc + r, yc - r), a1, a2, fillColor
               END IF
               IF last > first THEN
                  GRAPHIC LINE (x1, y1) - (x2, y2), fillColor
                  GRAPHIC SET PIXEL (x2, y2), fillColor
               END IF
               GRAPHIC SET POS (x, y)
               IF showNodes AND aids(i) = 0 THEN GRAPHIC PRINT STR$(i)
            NEXT i
            IF fillSect < 0 OR fillSect = j THEN
               'must find a point (x, y) inside polygon so that it can be filled
               x0 = polygons(first).x: y0 = polygons(first).y
               FOR i = first + 1 TO last - 1
                  x1 = polygons(i).x: y1 = polygons(i).y
                  x2 = polygons(i+1).x: y2 = polygons(i+1).y
                  x = (x1 + x2)/2: y = (y1 + y2)/2  'midpoint of side
                  IF x = x0 AND x1 = x2 THEN ITERATE
                  IF x <> x0 AND y <> y0 AND (y - y0)/(x - x0) = (y2 - y1)/(x2 - x1) THEN ITERATE
                  x = (x + x0)/2: y = (y + y0)/2
                  IF pointInsidePolygon(j, x, y) THEN EXIT FOR
               NEXT i
               GRAPHIC PAINT BORDER (x, y), fillColor, fillColor
            END IF
         ELSE 'plot circle, arc segment, radial block, or merge data
            i = sect(j).first: n = sect(j).last
            xc = arcs(n, 1): yc = arcs(n, 2): r = arcs(n, 3)
            a1 = arcs(n, 4): a2 = arcs(n, 5): t = arcs(n, 6)
            IF sect(j).nType = 3 THEN 'plot merge data
               r = MAX(xMax - xMin, yMax - yMin)/40
               GRAPHIC ELLIPSE (xc - r, yc + r) - (xc + r, yc - r)
               GRAPHIC CHR SIZE TO x, y
               GRAPHIC SET POS (xc - 2*x, yc + y/2)
               IF showNodes THEN GRAPHIC PRINT STR$(i)
               ITERATE
            END IF
            IF sect(j).nType = 1 THEN 'plot circle
               GRAPHIC ELLIPSE (xc - r, yc + r) - (xc + r, yc - r), fillColor
               x1 = xc + r: y1 = yc: x = xc: y = yc
               IF fillSect < 0 OR fillSect = j THEN
                  GRAPHIC PAINT BORDER (x, y), fillColor, fillColor
               END IF
            ELSEIF sect(j).nType = 4 THEN 'plot radial block
               a1 = a1*RAD: w = a2: a = a1: a2 = a + ATN(ABS(w)/SQR(r*r - w*w))*SGN(w)
               IF a1 > a2 THEN SWAP a1, a2
               x2 = xc + r*COS(a1): y2 = yc + r*SIN(a1)
               x4 = xc + r*COS(a2): y4 = yc + r*SIN(a2)
               GRAPHIC ARC (xc - r, yc + r) - (xc + r, yc - r), a1, a2, fillColor
               r = r - t: a1 = a: a2 = a + ATN(ABS(w)/SQR(r*r - w*w))*SGN(w)
               IF a1 > a2 THEN SWAP a1, a2
               x1 = xc + r*COS(a1): y1 = yc + r*SIN(a1)
               x3 = xc + r*COS(a2): y3 = yc + r*SIN(a2)
               GRAPHIC ARC (xc - r, yc + r) - (xc + r, yc - r), a1, a2, fillColor
               GRAPHIC LINE (x1, y1) - (x2, y2), fillColor
               GRAPHIC LINE (x3, y3) - (x4, y4), fillColor
               GRAPHIC SET PIXEL (x2, y2), fillColor
               GRAPHIC SET PIXEL (x4, y4), fillColor
               IF fillSect < 0 OR fillSect = j THEN
                  r = r + t/2: x = xc + r*COS((a1+a2)/2): y = yc + r*SIN((a1+a2)/2)
                  GRAPHIC PAINT BORDER (x, y), fillColor, fillColor
               END IF
            ELSE 'plot arc segment
               a1 = a1*RAD: a2 = a2*RAD
               GRAPHIC ARC (xc - r, yc + r) - (xc + r, yc - r), a1, a2, fillColor
               x2 = xc + r*COS(a1): y2 = yc + r*SIN(a1)
               x4 = xc + r*COS(a2): y4 = yc + r*SIN(a2)
               IF t < 0 THEN 'plot chord segment
                  GRAPHIC LINE (x2, y2) - (x4, y4), fillColor
                  GRAPHIC SET PIXEL (x4, y4), fillColor
                  t = r*(COS((a2 - a1)/2) - 1)
               ELSE
                  IF t THEN 'plot arc segment
                     r = r - t
                     GRAPHIC ARC (xc - r, yc + r) - (xc + r, yc - r), a1, a2, fillColor
                     x1 = xc + r*COS(a1): y1 = yc + r*SIN(a1)
                     x3 = xc + r*COS(a2): y3 = yc + r*SIN(a2)
                  ELSE 'plot pie segment
                     x1 = xc: y1 = yc: x3 = xc: y3 = yc: t = r: r = 0
                  END IF
                  GRAPHIC LINE (x1, y1) - (x2, y2), fillColor
                  GRAPHIC LINE (x3, y3) - (x4, y4), fillColor
                  GRAPHIC SET PIXEL (x2, y2), fillColor
                  GRAPHIC SET PIXEL (x4, y4), fillColor
               END IF
               IF fillSect < 0 OR fillSect = j THEN
                  IF a1 <> a2 THEN a = (a1 + a2)/2 ELSE a = a1 + PI
                  r = r + t/2: x = xc + r*COS(a): y = yc + r*SIN(a)
                  IF j = 2 THEN x = -.5: y = .75
                  GRAPHIC PAINT BORDER (x, y), fillColor, fillColor
               END IF
            END IF
            GRAPHIC SET POS (x1, y1)
            IF showNodes THEN GRAPHIC PRINT STR$(i)
         END IF
         IF zoom AND fillSect THEN
            GRAPHIC SET POS (x, y)
            GRAPHIC PRINT "x"
         END IF
      NEXT j
   NEXT pass
   GRAPHIC WIDTH 1: fillSect = 0
   GRAPHIC COLOR %BLUE
   IF numAids <= maxNodes AND showAids AND showNodes THEN
      FOR j = maxNodes TO numAids STEP -1
         GRAPHIC SET POS (polygons(j).x, polygons(j).y)
         GRAPHIC PRINT STR$(j)
      NEXT j
   END IF
   GRAPHIC COLOR %BLACK
   IF viewPrinAxes THEN
      r = MAX((xMax - xMin), (yMax - yMin))/10
      x = XCG: y = YCG: a = prinAngle*RAD
      GRAPHIC LINE (x - r*COS(a), y - r*SIN(a)) - (x + r*COS(a), y + r*SIN(a))
      GRAPHIC SET POS (x + r*COS(a), y + r*SIN(a)): GRAPHIC PRINT "p"
      GRAPHIC SET POS (x - r*COS(a), y - r*SIN(a)): GRAPHIC PRINT "p"
      a = a + PI/2
      GRAPHIC LINE (x - r*COS(a), y - r*SIN(a)) - (x + r*COS(a), y + r*SIN(a))
   END IF
END SUB

FUNCTION pointInsidePolygon(n AS LONG, x AS DOUBLE, y AS DOUBLE) AS LONG
   'http://astronomy.swin.edu.au/~pbourke/geometry/insidepoly/
   LOCAL i, j, first, last AS LONG
   LOCAL x1, y1, x2, y2, b, a1, a2, a, aSum AS DOUBLE
   first = sect(n).first: last = sect(n).last
   FOR i = first TO last
      j = i + 1: IF j > last THEN j = first
      x1 = polygons(i).x - x: y1 = polygons(i).y - y
      x2 = polygons(j).x - x: y2 = polygons(j).y - y
      a1 = ATN(y1/x1): IF x1 < 0 THEN a1 = PI + a1
      a2 = ATN(y2/x2): IF x2 < 0 THEN a2 = PI + a2
      a = a2 - a1
      WHILE (a > PI): a = a - twoPI: WEND
      WHILE (a < -PI): a = a + twoPI: WEND
      aSum = aSum + a
   NEXT i
   IF ABS(aSum) > PI THEN FUNCTION = 1
END FUNCTION

SUB calculate()
   '----------------------------------------------------------------------------------------
   'calculate section properties about its centroidal axes (A, Xbar, Ybar, Ixx, Iyy, Ixy)
   'also calculate section properties about the principal axes (Ipp, Iqq, angle)
   '----------------------------------------------------------------------------------------
   LOCAL i, j, k, n, first, last, sign AS LONG, s, fmt AS STRING
   LOCAL x, y, r, a1, a2, w, t AS SINGLE
   LOCAL x1, y1, x2, y2, x3, y3, x4, y4 AS DOUBLE
   LOCAL A, AX, AY, AXX, AYY, AXY, IXX, IYY, IXY, DI AS DOUBLE
   IF myPrintOn THEN DIALOG END myPrintHandle
   IF BIT(sect(numSections).flag, 0) = 0 THEN EXIT SUB
   REDIM prop(9) AS GLOBAL DOUBLE
   calcMode = MAX(1, calcMode)
   IF calcDone THEN GOTO showResults
   FOR j = 1 TO numSections
      REDIM sectProp(1:9)
      IF BIT(sect(j).flag, 1) OR BIT(sect(j).flag, 2) THEN ITERATE
      first = sect(j).first: last = sect(j).last: k = sect(j).nType
      IF k = 0 THEN 'calc polygon
         FOR i = first TO last
            IF arcs(i, 3) THEN 'calc fillet
               x1 = arcs(i, 6): y1 = arcs(i, 7)
               x2 = arcs(i, 8): y2 = arcs(i, 9)
               addLineSeg x1, y1, x2, y2
               sign = arcs(i, 0): x = arcs(i, 1): y = arcs(i, 2): r = arcs(i, 3)
               a1 = arcs(i, 4)*RAD: a2 = arcs(i, 5)*RAD
               addChordSeg sign, x, y, r, a1, a2
               x1 = x2: y1 = y2
            ELSE
               x1 = polygons(i).x: y1 = polygons(i).y
            END IF
            n = i + 1: IF i = last THEN n = first
            IF arcs(n, 3) THEN
               x2 = arcs(n, 6): y2 = arcs(n, 7)
            ELSE
               x2 = polygons(n).x: y2 = polygons(n).y
            END IF
            addLineSeg x1, y1, x2, y2
         NEXT i
      ELSEIF k = 1 THEN 'calc circle
         x = arcs(last, 1): y = arcs(last, 2): r = arcs(last, 3)
         A = PI*r*r: sectProp(1) = A: sectProp(2) = A*x: sectProp(3) = A*y
         sectProp(4) = A*x*x: sectProp(5) = A*y*y: sectProp(6) = A*x*y
         sectProp(7) = A*r*r/4: sectProp(8) = sectProp(7): sectProp(9) = 0
      ELSEIF k = 2 THEN 'calc arc segment
         t = arcs(last, 6): i = last
         IF t < 0 THEN
            sign = arcs(i, 0): x = arcs(i, 1): y = arcs(i, 2): r = arcs(i, 3)
            a1 = arcs(i, 4)*RAD: a2 = arcs(i, 5)*RAD
            addChordSeg sign, x, y, r, a1, a2
         ELSE
            addArcSeg last
         END IF
      ELSEIF k = 3 THEN 'calc merge data
         x = arcs(last, 1): y = arcs(last, 2): A = arcs(last, 3)
         sectProp(1) = A: sectProp(2) = A*x: sectProp(3) = A*y
         sectProp(4) = A*x*x: sectProp(5) = A*y*y: sectProp(6) = A*x*y
         sectProp(7) = arcs(n, 4): sectProp(8) = arcs(n, 5): sectProp(9) = arcs(n, 6)
      ELSE 'calc radial block
         x = arcs(last, 1): y = arcs(last, 2): r = arcs(last, 3)
         a1 = arcs(last, 4): w = arcs(last, 5): t = arcs(last, 6)
         a1 = a1*RAD: a = a1: a2 = a + ATN(ABS(w)/SQR(r*r - w*w))*SGN(w)
         IF a1 > a2 THEN SWAP a1, a2
         x2 = x + r*COS(a1): y2 = y + r*SIN(a1)
         x4 = x + r*COS(a2): y4 = y + r*SIN(a2)
         addChordSeg 1, x, y, r, a1, a2
         r = r - t: a1 = a: a2 = a + ATN(ABS(w)/SQR(r*r - w*w))*SGN(w)
         IF a1 > a2 THEN SWAP a1, a2
         x1 = x + r*COS(a1): y1 = y + r*SIN(a1)
         x3 = x + r*COS(a2): y3 = y + r*SIN(a2)
         addChordSeg -1, x, y, r, a1, a2
         addLineSeg x1, y1, x2, y2
         addLineSeg x2, y2, x4, y4
         addLineSeg x4, y4, x3, y3
         addLineSeg x3, y3, x1, y1
      END IF
      w = sect(j).wt*SGN(sectProp(1))
      FOR i = 1 TO 9
         prop(i) = prop(i) + w*sectProp(i)
      NEXT i
   NEXT j

   'now compute properties about centroidal axes
   AREA = prop(1): AX = prop(2): AY = prop(3)
   AXX = prop(4): AYY = prop(5): AXY = prop(6)
   IXX = prop(7): IYY = prop(8): IXY = prop(9)
   IF AREA <> 0 THEN XCG = AX/AREA: YCG = AY/AREA
   CGIXX = IXX + AYY - AY*YCG: CGIYY = IYY + AXX - AX*XCG
   CGIXY = IXY + AXY - AX*YCG

   'now compute properties about principal axes
   A = SQR((CGIXX - CGIYY)^2 + 4*CGIXY^2)
   IPP = (CGIXX + CGIYY + A)/2: IQQ = (CGIXX + CGIYY - A)/2
   DI = CGIXX - CGIYY
   IF ABS(CGIXY / IPP) < .000001 THEN
      IF DI/MAX(CGIXX, CGIYY) < -.000001 THEN prinAngle = 90 ELSE prinAngle = 0
   ELSEIF ABS(DI / IPP) < .000001 THEN
      prinAngle = -45*SGN(CGIXY)
   ELSE
      IF DI > 0 THEN prinAngle = -ATN(2*CGIXY/DI)/RAD/2
      IF DI < 0 THEN prinAngle = 90 - ATN(2*CGIXY/DI)/RAD/2
   END IF
   calcDone = 1

   showResults:
   DIM calcProp(12) AS STRING 'calcProp() will be used again for printing
   fmt = "#." + STRING$(numDigits, "0")
   IF numDigits = 0 THEN fmt = REMOVE$(fmt, ".")
   calcProp(0) = " Centroidal Axes"
   calcProp(1) = ""
   calcProp(2) = " Area " + $TAB + "=   " + FORMAT$(AREA, fmt)
   calcProp(3) = " xBar " + $TAB + "=   " + FORMAT$(XCG, fmt)
   calcProp(4) = " yBar " + $TAB + "=   " + FORMAT$(YCG, fmt)
   calcProp(5) = " Ixx  " + $TAB + "=   " + FORMAT$(CGIXX, fmt)
   calcProp(6) = " Iyy  " + $TAB + "=   " + FORMAT$(CGIYY, fmt)
   calcProp(7) = " Ixy  " + $TAB + "=   " + FORMAT$(CGIXY, fmt)
   calcProp(8) = " Principal Axes"
   calcProp(9) = ""
   calcProp(10) = " Imax " + $TAB + "=   " + FORMAT$(IPP, fmt)
   calcProp(11) = " Imin " + $TAB + "=   " + FORMAT$(IQQ, fmt)
   calcProp(12) = "Angle " + $TAB + "=   " + FORMAT$(prinAngle, fmt) + "  Degrs"
   IF calcMode = 2 THEN calcMode = 0: EXIT SUB

   FOR i = 0 TO 12
      myPrint calcProp(i)
      IF i = 7 THEN myPrint: myPrint
   NEXT i
   myPrintOn = 1: myPrintAll 250, 300, "Section Properties"
   myPrintOn = 0
END SUB

SUB addLineSeg(x1 AS DOUBLE, y1 AS DOUBLE, x2 AS DOUBLE, y2 AS DOUBLE)
   LOCAL area, x, y, dx, dy AS DOUBLE
   area = (x1*y2 - x2*y1)/2: x = (x1 + x2)/3: y = (y1 + y2)/3
   sectProp(1) = sectProp(1) + area
   sectProp(2) = sectProp(2) + area*x
   sectProp(3) = sectProp(3) + area*y
   sectProp(4) = sectProp(4) + area*x*x
   sectProp(5) = sectProp(5) + area*y*y
   sectProp(6) = sectProp(6) + area*x*y
   dx = x2 - x1: dy = y2 -y1:
   sectProp(7) = sectProp(7) + area/8 * (y*y + dy*dy/3)
   sectProp(8) = sectProp(8) + area/8 * (x*x + dx*dx/3)
   sectProp(9) = sectProp(9) + area/8 * (x*y + dx*dy/3)
END SUB

SUB addChordSeg(sign AS LONG, xc AS SINGLE, yc AS SINGLE, r AS SINGLE, a1 AS SINGLE, a2 AS SINGLE)
   LOCAL h, ci1, ci2, av, s, c, rr, area, x, y, angl, alfa AS DOUBLE
   LOCAL i, j, k AS LONG, msg AS STRING
   a1 = a1: a2 = a2: angl = (a1 + a2)/2: alfa = ABS(a2 - a1)/2
   s = SIN(alfa): c = COS(alfa)
   a1 = alfa - s*c: a2 = 2*c*s^3
   IF a1 = 0 THEN
      IF r THEN MSGBOX "Error calculating chord segment", %MB_ICONERROR, "Chord Segment"
      EXIT SUB
   END IF
   h = r*(2*s^3/3/a1): ci1 = r^4*(a1 + a2 -16*s^6/9/a1)/4: ci2 = r^4*(3*a1 - a2)/12
   IF ABS(ci1) > ABS(ci2) THEN SWAP ci1, ci2
   area = sign*r*r*a1: x = xc + h*COS(angl): y = yc + h*SIN(angl)
   sectProp(1) = sectProp(1) + area
   sectProp(2) = sectProp(2) + area*x
   sectProp(3) = sectProp(3) + area*y
   sectProp(4) = sectProp(4) + area*x*x
   sectProp(5) = sectProp(5) + area*y*y
   sectProp(6) = sectProp(6) + area*x*y
   av = (ci1 + ci2)/2: rr = (ci2 - ci1)/2
   sectProp(7) = sectProp(7) + av + rr*COS(2*angl)
   sectProp(8) = sectProp(8) + av - rr*COS(2*angl)
   sectProp(9) = sectProp(9) - rr*SIN(2*angl)
END SUB

SUB addArcSeg(n AS LONG)
   LOCAL xc, yc, r, a1, a2, t, angl, alfa AS DOUBLE
   LOCAL s, c, h, ci, ci1, ci2, av, rr, area, x, y AS DOUBLE
   xc = arcs(n, 1): yc = arcs(n, 2): r = arcs(n, 3)
   a1 = arcs(n, 4): a2 = arcs(n, 5): t = arcs(n, 6)/r
   a1 = a1*RAD: a2 = a2*RAD: IF t = 0 THEN t = 1
   IF a1 = a2 THEN a2 = a1 + 2*PI
   IF a1 > a2 THEN a1 = a1 - 2*PI
   alfa = (a2 - a1)/2: angl = (a1 + a2)/2
   s = SIN(alfa): c = COS(alfa): h = 2*r*s/3/alfa*(1 - t + 1/(2 - t))
   area = alfa*r*r*(2*t - t*t): x = xc + h*COS(angl): y = yc + h*SIN(angl)
   ci = (1 - 1.5*t + t*t - t^3/4): ci2 = r^4*t*ci*(alfa - s*c)
   ci1 = r^4*t*(ci*(alfa + s*c - 2*s*s/alfa) + (s*t)^2/3/alfa/(2 - t)*(1 - t*t + t/6))
   av = (ci1 + ci2)/2: rr = (ci2 - ci1)/2
   sectProp(1) = area: sectProp(2) = area*x: sectProp(3) = area*y
   sectProp(4) = area*x*x: sectProp(5) = area*y*y: sectProp(6) = area*x*y
   sectProp(7) = av + rr*COS(2*angl): sectProp(8) = av - rr*COS(2*angl)
   sectProp(9) = -rr*SIN(2*angl)
END SUB

SUB calcOtherAxes(x0 AS DOUBLE, y0 AS DOUBLE, angl AS DOUBLE)
   LOCAL x, y, c, s AS DOUBLE
   LOCAL IXX0, IYY0, IXY0, IXX, IYY, IXY AS DOUBLE
   calcMode = 2: IF calcDone = 0 THEN calculate
   x = XCG - x0: y = YCG - y0: c = COS(angl*RAD): s = SIN(angl*RAD)
   IXX0 = CGIXX + area*y*y: IYY0 = CGIYY + area*x*x: IXY0 = CGIXY + area*x*y
   IXX = IXX0*c*c - 2*IXY0*s*c + IYY0*s*s
   IYY = IXX0*s*s + 2*IXY0*s*c + IYY0*c*c
   IXY = IXY0*(c*c - s*s) + (IXX0 - IYY0)*s*c
   DIALOG NEW hDlg, "Property Calculations", 150, 80, 150, 120, %WS_SYSMENU TO hCalc
   CONTROL ADD LABEL, hCalc, -1, "Ixx " + $TAB + "=   " + FORMAT$(IXX, "#.000"), 20, 10, 250, 15
   CONTROL ADD LABEL, hCalc, -1, "Iyy " + $TAB + "=   " + FORMAT$(IYY, "#.000"), 20, 25, 250, 15
   CONTROL ADD LABEL, hCalc, -1, "Ixy " + $TAB + "=   " + FORMAT$(IXY, "#.000"), 20, 40, 250, 15
   DIALOG SHOW MODAL hCalc
   calcMode = 0
END SUB

SUB preferences
   LOCAL hPref, nStyle AS LONG
   DIALOG NEW hDlg, "Preferences", 150, 80, 120, 90, %WS_SYSMENU TO hPref
   CONTROL ADD LABEL, hPref, -1, "Significant digits:", 10, 10, 60, 12
   nStyle = %WS_TABSTOP OR %CBS_DROPDOWNLIST
   CONTROL ADD COMBOBOX, hPref, %ID_NumDigits, , 70, 10, 40, 90, nStyle
   CONTROL ADD CHECKBOX, hPref, %ID_LastFile, "Open last file saved", 10, 25, 85, 15
   CONTROL ADD BUTTON, hPref, %IDOK, "Ok", 10, 45, 50, 20
   DIALOG SHOW MODAL hPref, CALL preferencesProc
END SUB

CALLBACK FUNCTION preferencesProc()
   LOCAL i AS LONG, s AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         FOR i = 0 TO 6
            COMBOBOX ADD CBHNDL, %ID_NumDigits, STR$(i)
         NEXT i
         COMBOBOX SELECT CBHNDL, %ID_NumDigits, numDigits + 1
         i = lastFile: CONTROL SET CHECK CBHNDL, %ID_LastFile, i
      CASE %WM_COMMAND
         IF CBCTL = %IDOK THEN
            COMBOBOX GET TEXT CBHNDL, %ID_NumDigits TO s: numDigits = VAL(s)
            CONTROL GET CHECK CBHNDL, %ID_LastFile TO i: lastFile = i
            DIALOG END CBHNDL: saveIniFile
         END IF
   END SELECT
END FUNCTION

SUB logFile()
   LOCAL i, j, k, n, first, last AS LONG
   LOCAL x, y, r, a1, a2, t, area, Ixx, Iyy, Ixy, wt AS DOUBLE
   LOCAL s, ss, sss, fmt AS STRING
   IF myPrintOn THEN DIALOG END myPrintHandle
   DIM sType(4) AS STRING
   sType(0) = "polygon"
   sType(1) = "circle"
   sType(2) = "arc segment"
   sType(3) = "merge data"
   sType(4) = "radial block"
   fmt = "* #." + STRING$(numDigits, "0")
   IF numDigits = 0 THEN fmt = REMOVE$(fmt, ".")
   FOR j = 1 TO numSections
      IF BIT(sect(j).flag, 2) THEN ITERATE
      first = sect(j).first: last = sect(j).last
      n = sect(j).nType: wt = sect(j).wt: ss = sType(n): sss = ""
      IF BIT(sect(j).flag, 2) THEN sss = ", deleted"
      IF BIT(sect(j).flag, 1) THEN sss = ", off state"
      IF BIT(sect(j).flag, 0) THEN sss = ", Wt = " + TRIM$(FORMAT$(wt, fmt))
      IF j > 1 THEN myPrint
      IF n = 0 THEN 'polygon
         myPrint "Section" + STR$(j) + " (" + ss + sss + ")"
         myPrint "Node    x           y           r"
         IF n = 0 THEN
            FOR i = first TO last
               x = polygons(i).x: y = polygons(i).y: r = arcs(i, 3)
               s = FORMAT$(i, "* #") + $TAB + FORMAT$(x, fmt) + $TAB + FORMAT$(y, fmt) + $TAB + FORMAT$(r, fmt)
               myPrint TAB$(s, 6)
            NEXT i
         END IF
      ELSEIF n = 1 OR n = 2 OR n = 4 THEN 'circle, arc segment, or radial block
         x = arcs(last, 1): y = arcs(last, 2): r = arcs(last, 3)
         a1 = arcs(last, 4): a2 = arcs(last, 5): t = arcs(last, 6)
         myPrint "Section" + STR$(j) + " (" + ss + sss + ")"
         myPrint "Node    x           y           r"
         IF n = 2 THEN
            myPrint "        a1          a2          t"
         ELSEIF n = 4 THEN
            myPrint "        angl        w           t"
         END IF
         s = FORMAT$(first, "* #") + $TAB + FORMAT$(x, fmt) + $TAB + FORMAT$(y, fmt) + $TAB + FORMAT$(r, fmt)
         myPrint TAB$(s, 6)
         IF n = 2 OR n = 4 THEN
            s = $TAB + FORMAT$(a1, fmt) + $TAB + FORMAT$(a2, fmt) + $TAB + FORMAT$(t, fmt)
            myPrint TAB$(s, 6)
         END IF
      ELSEIF n = 3 THEN 'merge data
         x = arcs(last, 1): y = arcs(last, 2): area = arcs(last, 3)
         Ixx = arcs(last, 4): Iyy = arcs(last, 5): Ixy = arcs(last, 6)
         myPrint "Section" + STR$(j) + " (" + ss + sss + ")"
         myPrint "Node    xc          yc          A"
         myPrint "        Ixx         Iyy         Ixy"
         s = FORMAT$(first, "* #") + $TAB + FORMAT$(x, fmt) + $TAB + FORMAT$(y, fmt) + $TAB + FORMAT$(area, fmt)
         myPrint TAB$(s, 6)
         s = $TAB + FORMAT$(Ixx, fmt) + $TAB + FORMAT$(Iyy, fmt) + $TAB + FORMAT$(Ixy, fmt)
         myPrint TAB$(s, 6)
      END IF
   NEXT j
   IF numAids <= maxNodes THEN
      myPrint: myPrint "Phantom Points"
      FOR j = maxNodes TO numAids STEP -1
         x = polygons(j).x: y = polygons(j).y
         s = FORMAT$(j, "* #") + $TAB + FORMAT$(x, fmt) + $TAB + FORMAT$(y, fmt) + $TAB + FORMAT$(r, fmt)
         myPrint TAB$(s, 6)
      NEXT j
   END IF
   myPrintOn = 1: myPrintAll 400, 200, "Log File"
   myPrintOn = 0
END SUB

FUNCTION makeFont(fontName AS STRING, BYVAL fontSize AS LONG, OPT BYVAL fontAttr AS STRING) AS LONG
   'specify combination of descr = b for bold, u for underline, i for italic
   'fontName such as Arial, Courier, Courier New, Times New Roman, MS Sans Serif
   LOCAL hDC AS LONG, CyPixels AS LONG, charHt AS LONG, wt AS DWORD
   LOCAL bold AS DWORD, underline AS DWORD, italic AS DWORD
   IF LEN(fontAttr) THEN
      BOLD = INSTR(fontAttr, "b") + 300
      underline = INSTR(fontAttr,"u")
      italic = INSTR(fontAttr,"i")
   END IF
   hDC = GetDC(%HWND_DESKTOP)
   CyPixels  = GetDeviceCaps(hDC, %LOGPIXELSY)
   ReleaseDC %HWND_DESKTOP, hDC
   charHt = (fontSize * CyPixels) \ 72
   wt = %FW_NORMAL + BOLD
   FUNCTION = CreateFont(-charHt, 0, 0, 0, wt, italic, underline, 0, _
              %ANSI_CHARSET, %OUT_TT_PRECIS, %CLIP_DEFAULT_PRECIS, _
              %DEFAULT_QUALITY, %FF_DONTCARE, BYCOPY fontName)
END FUNCTION

SUB openIniFile()
   LOCAL fileNo, n AS LONG, f AS STRING
   f = dataFolder + "\winSect.ini"
   IF ISFILE(f) THEN
      fileNo = FREEFILE
      OPEN f FOR INPUT AS fileNo
      INPUT #fileNo, numDigits
      INPUT #fileNo, lastFile
      INPUT #fileNo, f
      IF lastFile THEN thisFile = f
      CLOSE fileNo
   END IF
END SUB

SUB saveIniFile()
   LOCAL fileNo AS LONG
   fileNo = FREEFILE
   OPEN dataFolder + "\winSect.ini" FOR OUTPUT AS fileNo
   WRITE #fileNo, numDigits
   WRITE #fileNo, lastFile
   WRITE #fileNo, thisFile
   CLOSE fileNo
END SUB

SUB openTheFile()
   LOCAL fileNo, i, j, fi, numArcs AS LONG, ver AS STRING
   fileNo = FREEFILE
   OPEN thisFile FOR BINARY AS fileNo
   ver = $version
   GET fileNo, , ver
   IF LEFT$(ver, 7) <> "winSect" THEN
      MSGBOX "   Wrong file type   ", %MB_ICONERROR, "Error": EXIT SUB
   END IF
   GET fileNo, , numNodes
   GET fileNo, , numSections
   GET fileNo, , numArcs
   DIM f(numNodes) AS LONG
   DIM arcsIn(numArcs, 9) AS SINGLE
   FOR i = 1 TO numSections
      GET fileNo, , sect(i)
      BIT RESET sect(i).flag, 3
      BIT RESET sect(i).flag, 4
      fi = sect(i).last: j = sect(i).first
      IF sect(i).nType THEN 'circles, arcs, merge
         f(j) = fi: sect(i).last = j
      END IF
   NEXT i
   FOR i = 1 TO numNodes
      GET fileNo, , polygons(i)
      GET fileNo, , fi
      IF fi THEN f(i) = fi  'fillets
   NEXT i
   FOR i = 1 TO numArcs
      FOR j = 0 TO 9
         GET fileNo, , arcsIn(i, j)
      NEXT j
   NEXT i
   FOR i = 1 TO numNodes
      fi = f(i)
      FOR j = 0 TO 9
         arcs(i, j) = arcsIn(fi, j)
      NEXT j
   NEXT i
   CLOSE fileNo
   calcDone = 0: sectNo = numSections
END SUB

SUB saveTheFile()
   LOCAL fileNo, i, j, numArcs AS LONG
   LOCAL ver AS STRING
   IF fileChanged THEN
      DIM f(numNodes) AS LONG
      FOR i = 1 TO numNodes
         'determine rows in arcs() to save
         IF arcs(i, 3) THEN INCR numArcs: f(i) = numArcs
      NEXT i
      FOR i = 1 TO numSections
         IF sect(i).nType THEN sect(i).last = f(sect(i).first)
      NEXT i
      fileNo = FREEFILE
      OPEN thisFile FOR BINARY AS fileNo
      ver = $version
      PUT fileNo, , ver
      PUT fileNo, , numNodes
      PUT fileNo, , numSections
      PUT fileNo, , numArcs
      FOR i = 1 TO numSections
         PUT fileNo, , sect(i)
      NEXT i
      FOR i = 1 TO numNodes
         PUT fileNo, , polygons(i)
         PUT fileNo, , f(i)
      NEXT i
      FOR i = 1 TO numNodes
         IF f(i) THEN
            FOR j = 0 TO 9
               PUT fileNo, , arcs(i, j)
            NEXT j
         END IF
      NEXT i
      CLOSE fileNo
   END IF
   fileChanged = 0: saveIniFile
END SUB

FUNCTION doNotQuit() AS LONG
   LOCAL n AS INTEGER
   IF fileChanged THEN
      n = MSGBOX("File has changed..." & $CRLF _
      & "Save the file?", %MB_YESNOCANCEL + %MB_ICONQUESTION, "Save File")
      IF n = %IDCANCEL THEN
         FUNCTION = 1
      ELSEIF n = %IDYES THEN
         IF LEN(thisFile) THEN
            saveTheFile
         ELSE
            DIALOG SEND hDlg, %WM_COMMAND, %IDM_SaveAs, 0
         END IF
      END IF
   END IF
END FUNCTION

FUNCTION choosePrinter() AS STRING
   'gPrinterSelected, gLastPrinterSelected are global strings
   LOCAL hPrnDlg AS LONG, STYLE AS LONG, result AS ASCIIZ PTR
   DIALOG NEW hDlg, "Choose Printer", , , 240, 140, %WS_SYSMENU TO hPrnDlg
   STYLE = %WS_TABSTOP OR %WS_VSCROLL
   CONTROL ADD LISTBOX, hPrnDlg, %ID_Listbox, , 10, 10, 220, 60, STYLE, %WS_EX_CLIENTEDGE
   CONTROL ADD BUTTON, hPrnDlg, %IDOK, "Ok", 125, 80, 50, 25
   CONTROL ADD BUTTON, hPrnDlg, %IDCANCEL, "Cancel", 180, 80, 50, 25
   DIALOG SHOW MODAL hPrnDlg, CALL choosePrinterProc
   FUNCTION = gPrinterSelected
END FUNCTION

CALLBACK FUNCTION choosePrinterProc()
   LOCAL needed AS LONG, returned AS LONG, i AS LONG, nSize AS LONG
   LOCAL s AS STRING, defaultPrinter AS STRING, printerName AS ASCIIZ * 128
   LOCAL hPrnDC AS LONG, hPrinter AS LONG, m AS LONG, n AS LONG, level AS LONG
   LOCAL dm AS STRING, pDevMode AS DEVMODE PTR, dwNeeded AS LONG, pPrnName AS ASCIIZ PTR
   DIM pr(0) AS STATIC PRINTER_INFO_2
   SELECT CASE CBMSG
   CASE %WM_INITDIALOG
      level = 2
      'First call to see how big the WINDOWS PRINTER_INFO_2 structure needs to be
      n = %PRINTER_ENUM_LOCAL OR %PRINTER_ENUM_CONNECTIONS
      EnumPrinters n, $NUL, BYVAL level, BYVAL %NULL, 0, needed, returned
      REDIM pr(Needed \ SIZEOF(pr(0))): nSize = SIZEOF(pr(0)) * (UBOUND(pr) + 1)
      EnumPrinters n, $NUL, level, BYVAL VARPTR(pr(0)), nSize, needed, returned
      IF returned > 0 THEN
         'get the default printer
         CALL GetProfileString("WINDOWS", "DEVICE", ",,,", PrinterName, SIZEOF(PrinterName))
         defaultPrinter = TRIM$(PARSE$(PrinterName,",",1))
         FOR i = 0 TO returned - 1
            s =  pr(i).@pPrinterName
            IF TRIM$(s, ANY CHR$(0,32)) = defaultPrinter THEN n = i
            IF TRIM$(s, ANY CHR$(0,32)) = gLastPrinterSelected THEN m = i
            LISTBOX ADD CBHNDL, %ID_Listbox, s
         NEXT i
         IF m THEN n = m
         LISTBOX SELECT CBHNDL, %ID_Listbox, n + 1
      END IF
   CASE %WM_COMMAND
      IF CBCTL = %IDOK THEN
         CONTROL SEND CBHNDL, %ID_Listbox, %LB_GETCURSEL, 0, 0 TO i
         CONTROL SEND CBHNDL, %ID_Listbox, %LB_GETTEXT, i, VARPTR(printerName)
         gPrinterSelected = printerName: gLastPrinterSelected = gPrinterSelected
         DIALOG END CBHNDL
      ELSEIF CBCTL = %IDCANCEL THEN
         DIALOG END CBHNDL
      END IF
   END SELECT
END FUNCTION

SUB printSect()
   LOCAL i, j, n, first, last, prn AS LONG, s, prnName AS STRING
   LOCAL x, y, x1, y1, x2, y2, x3, y3, x4, y4, xc, yc AS SINGLE  'DOUBLE
   LOCAL r, g, a, a1, a2, t, w, wi, ht, ar, u, v AS SINGLE  'DOUBLE
   'first, print results and file name -----------------------------------------
   prnName = choosePrinter()
   IF LEN(prnName) = 0 THEN EXIT SUB
   XPRINT ATTACH prnName
   IF ERR <> 0 OR XPRINT$ = "" THEN
      MSGBOX "Printer connection failed": EXIT SUB
   END IF
   IF calcDone = 0 THEN calcMode = 2: calculate
   XPRINT GET SIZE TO wi, ht: x1 = .15*wi: x2 = .55*wi
   XPRINT CHR SIZE TO x, y: y1 = 3*y
   XPRINT SET POS (x1, y1)
   XPRINT thisFile
   y1 = y1 + y
   XPRINT SET POS (x1, y1)
   FOR i = 0 TO 7
      XPRINT SET POS (x1, y1 + i*y)
      XPRINT calcProp(i)
   NEXT i
   XPRINT SET POS (x2, y1)
   FOR i = 0 TO 4
      XPRINT SET POS (x2, y1 + i*y)
      XPRINT calcProp(i + 8)
   NEXT i
   'now, print the section -----------------------------------------------------
   x = xMax - xMin: IF x = 0 THEN x = 0.5
   y = yMax - yMin: IF y = 0 THEN y = 0.5
   g = MAX(x, y): x = (xMin + xMax)/2: y = (yMin + yMax)/2
   XPRINT GET MARGIN TO x1, y1, x2, y2
   wi = wi - x1 - x2: ht = ht - y1 - y2: ar = wi / ht: u = 1.2: v = 1.2
   'u, v are used to position the center of the plot
   'ar is aspect ratio, needed to show square with equal sides
   XPRINT SCALE (ar*(u*x - g), v*y + g) - (ar*(u*x + g), v*y - g)
   GRAPHIC COLOR %BLACK
   FOR j = 1 TO numSections
      IF BIT(sect(j).flag, 1) OR BIT(sect(j).flag, 2) THEN ITERATE
      IF j <> viewOne AND viewOne THEN ITERATE
      IF sect(j).nType = 0 THEN 'print polygon
         first = sect(j).first: last = sect(j).last
         FOR i = first TO last
            x1 = polygons(i).x: y1 = polygons(i).y: x = x1: y = y1
            IF i < last THEN
               x2 = polygons(i + 1).x: y2 = polygons(i + 1).y
               IF arcs(i + 1, 3) THEN x2 = arcs(i + 1, 6): y2 = arcs(i + 1, 7)
            ELSEIF i = last AND BIT(sect(j).flag, 0) THEN
               x2 = polygons(first).x: y2 = polygons(first).y
               IF arcs(first, 3) THEN x2 = arcs(first, 6): y2 = arcs(first, 7)
            END IF
            IF arcs(i, 3) THEN
               x1 = arcs(i, 8): y1 = arcs(i, 9)
               xc = arcs(i, 1): yc = arcs(i, 2): r = arcs(i, 3)
               a1 = arcs(i, 4)*RAD: a2 = arcs(i, 5)*RAD
               XPRINT ARC (xc - r, yc + r) - (xc + r, yc - r), a1, a2
            END IF
            IF last > first THEN XPRINT LINE (x1, y1) - (x2, y2)
         NEXT i
      ELSE 'print circle, arc segment, radial block, or merge data
         i = sect(j).first: n = sect(j).last
         xc = arcs(n, 1): yc = arcs(n, 2): r = arcs(n, 3)
         a1 = arcs(n, 4): a2 = arcs(n, 5): t = arcs(n, 6)
         IF sect(j).nType = 3 THEN 'print merge data
            r = MAX(xMax - xMin, yMax - yMin)/40
            XPRINT ELLIPSE (xc - r, yc + r) - (xc + r, yc - r)
            ITERATE
         END IF
         IF sect(j).nType = 1 THEN 'print circle
            XPRINT ELLIPSE (xc - r, yc + r) - (xc + r, yc - r)
            'x1 = xc + r: y1 = yc
         ELSEIF sect(j).nType = 4 THEN 'print radial block
            a1 = a1*RAD: w = a2: a = a1: a2 = a + ATN(ABS(w)/SQR(r*r - w*w))*SGN(w)
            IF a1 > a2 THEN SWAP a1, a2
            x2 = xc + r*COS(a1): y2 = yc + r*SIN(a1)
            x4 = xc + r*COS(a2): y4 = yc + r*SIN(a2)
            XPRINT ARC (xc - r, yc + r) - (xc + r, yc - r), a1, a2
            r = r - t: a1 = a: a2 = a + ATN(ABS(w)/SQR(r*r - w*w))*SGN(w)
            IF a1 > a2 THEN SWAP a1, a2
            x1 = xc + r*COS(a1): y1 = yc + r*SIN(a1)
            x3 = xc + r*COS(a2): y3 = yc + r*SIN(a2)
            XPRINT ARC (xc - r, yc + r) - (xc + r, yc - r), a1, a2
            XPRINT LINE (x1, y1) - (x2, y2)
            XPRINT LINE (x3, y3) - (x4, y4)
         ELSE 'print arc segment
            a1 = arcs(n, 4)*RAD: a2 = arcs(n, 5)*RAD: t = arcs(n, 6)
            XPRINT ARC (xc - r, yc + r) - (xc + r, yc - r), a1, a2
            x1 = xc + r*COS(a1): y1 = yc + r*SIN(a1)
            x2 = xc + r*COS(a2): y2 = yc + r*SIN(a2)
            IF t < 0 THEN 'print chord segment
               XPRINT LINE (x1, y1) - (x2, y2)
            ELSE
               IF t THEN
                  r = r - t
                  XPRINT ARC (xc - r, yc + r) - (xc + r, yc - r), a1, a2
                  x3 = xc + r*COS(a1): y3 = yc + r*SIN(a1)
                  x4 = xc + r*COS(a2): y4 = yc + r*SIN(a2)
               ELSE
                  x3 = xc: y3 = yc: x4 = xc: y4 = yc
               END IF
               XPRINT LINE (x1, y1) - (x3, y3)
               XPRINT LINE (x2, y2) - (x4, y4)
            END IF
         END IF
      END IF
   NEXT j
   IF viewPrinAxes THEN
      r = MAX((xMax - xMin), (yMax - yMin))/10
      x = XCG: y = YCG: a = prinAngle*RAD
      XPRINT LINE (x - r*COS(a), y - r*SIN(a)) - (x + r*COS(a), y + r*SIN(a))
      XPRINT SET POS (x + r*COS(a), y + r*SIN(a)): XPRINT "p"
      XPRINT SET POS (x - r*COS(a), y - r*SIN(a)): XPRINT "p"
      a = a + PI/2
      XPRINT LINE (x - r*COS(a), y - r*SIN(a)) - (x + r*COS(a), y + r*SIN(a))
   END IF
   XPRINT CLOSE
END SUB

FUNCTION createFolder(folder AS STRING) AS LONG
   LOCAL i, COUNT, PARTS() AS LONG, s AS STRING
   COUNT = PARSECOUNT(folder, "\")
   DIM PARTS(COUNT)
   FOR i = 1 TO COUNT
      s = s + PARSE$(folder, "\", i) + "\"
      IF ISFOLDER(s) = 0 THEN MKDIR s
   NEXT i
   FUNCTION = ISFOLDER(folder)  'return 0 on failure
END FUNCTION

FUNCTION SpecialFolder(BYVAL pidl AS DWORD) AS STRING
' by Wayne Diamond 12-03-01
' http://www.powerbasic.com/support/forums/Forum7/HTML/001233.html
'===================================================================================================
   LOCAL TmpAsciiz AS ASCIIZ * %MAX_PATH
   CoInitialize BYVAL 0
   IF ISFALSE(SHGetSpecialFolderLocation(BYVAL %HWND_DESKTOP, BYVAL pidl, BYVAL VARPTR(pidl))) THEN
      SHGetPathFromIDList BYVAL pidl, TmpAsciiz
      CoTaskMemFree BYVAL pidl
   END IF
   CoUninitialize
   FUNCTION = TmpAsciiz
END FUNCTION

SUB showAbout
   LOCAL hAbout AS LONG, s AS STRING
   DIALOG NEW hDlg,"About winSect",,, 220, 160, %WS_SYSMENU TO hAbout
   CONTROL ADD LABEL, hAbout, 101, "Section Properties", 40, 10, 150, 20
   CONTROL ADD LABEL, hAbout, 102, " for Windows", 145, 13, 70, 10
   s = "Beta version " + MID$($version, 9) + " - Free distribution" + $CRLF
   s = s + "by Charles G. Dietz" + $CRLF + $CRLF
   CONTROL ADD LABEL, hAbout, 103, s, 40, 25, 180, 30
   s = "chasdietz@verizon.net"
   CONTROL ADD LABEL, hAbout, 104, s, 60, 60, 140, 12, %SS_NOPREFIX OR %SS_NOTIFY
   s = "http://www.cgdsoftware.com"
   CONTROL ADD LABEL, hAbout, 105, s, 60, 75, 140, 12, %SS_NOPREFIX OR %SS_NOTIFY
   CONTROL ADD IMAGE, hAbout, -1, "sect", 10, 10, 30, 30
   DIALOG SHOW MODAL hAbout, CALL showAboutProc
END SUB

CALLBACK FUNCTION showAboutProc()
   LOCAL hdc, hFont, hOrigFont AS LONG
   LOCAL url, email AS ASCIIZ*64
   SELECT CASE CBMSG
   CASE %WM_PAINT
      hFont = makeFont("MS Sans Serif", 14)
      CONTROL SET COLOR CBHNDL, 101, %RED, -1
      CONTROL SEND CBHNDL, 101, %WM_SETFONT, hFont, 1
      DeleteObject hFont
      hFont = makeFont("MS Sans Serif", 10, "i")
      CONTROL SEND CBHNDL, 102, %WM_SETFONT, hFont, 1
      DeleteObject hFont
      hFont = makeFont("MS Sans Serif", 10)
      CONTROL SEND CBHNDL, 103, %WM_SETFONT, hFont, 1
      DeleteObject hFont
      hFont = makeFont("MS Sans Serif", 10, "u")
      CONTROL SET COLOR CBHNDL, 104, %BLUE, -1
      CONTROL SEND CBHNDL, 104, %WM_SETFONT, hFont, 1
      DeleteObject hFont
      hFont = makeFont("MS Sans Serif", 10, "u")
      CONTROL SET COLOR CBHNDL, 105, %BLUE, -1
      CONTROL SEND CBHNDL, 105, %WM_SETFONT, hFont, 1
      DeleteObject hFont
   CASE %WM_SETCURSOR  'Change cursor to hand when hovering over label
      IF GetDlgCtrlId(CBWPARAM) >= 104 THEN
         SetCursor LoadCursor(GetModuleHandle(""), "HAND")
         SetWindowLong CBHNDL, %DWL_MSGRESULT, 1: FUNCTION = 1
      END IF
   CASE %WM_COMMAND
      IF CBCTL = %IDOK OR CBCTL = %IDCANCEL THEN
         DIALOG END CBHNDL
      ELSEIF CBCTL = 104 THEN
         MOUSEPTR 11
         email = "chasdietz@verizon.net"
         ShellExecute(0, "open", "mailto:" + email + "?", "", "", %SW_SHOW)
      ELSEIF CBCTL = 105 THEN
         MOUSEPTR 11
         url = "http://www.cgdsoftware.com"
         ShellExecute(BYVAL %NULL, "open", url, BYVAL %NULL, BYVAL %NULL,%SW_SHOWMAXIMIZED)
      END IF
   END SELECT
END FUNCTION
